//-------------------------------------- Global -------------------------------------- 
var canvas = document.getElementById("canvas");
var ctx = canvas.getContext("2d");

var fps = 15;
var mouse=[];
var mouseDown = [];
var mouseOver = [0,0];
var keysPressed = {};
var soundOn= true; 

//TODO rename undersec to tick
var underSec = 0;
var levelSec = 0;

var current = "loader";
var isRunning = true;

canvas.addEventListener('mousemove', function(event) { mouseOver = [event.clientX, event.clientY]});
canvas.addEventListener('mouseup', function(event) { 	mouseDown =[],	mouse = []});
canvas.addEventListener('mousedown', function(event) { mouse = [],	mouseDown = [event.clientX, event.clientY]});

canvas.addEventListener('touchend', function(event)   { mouseDown =[],	mouse = []});
canvas.addEventListener('touchstart', function(event) { mouse = [],	mouseDown = [event.clientX, event.clientY]});

onkeydown = function(e){
  // keysPressed = {};
  e = e || event; // to deal with IE
  keysPressed[e.keyCode] = e.type == 'keydown';
}

onkeyup = function(e){
  // if there are all keys up than reset the keyPressed obj
  var resetKeys = true;
  keysPressed[e.keyCode] = false;
  for (var i in keysPressed) {
    if (keysPressed[i]) {
      resetKeys = false;
    }
  }

  if (resetKeys) keysPressed = {}
}

// test if keysPressed is empty
function isEmpty(obj) { 
  for (var x in obj) { return false; }
  return true;
}

//-------------------------------------- Loader -------------------------------------- 
var imagesCount = images.length;
var imagesLoaded = 0;
var img = {};

var soundsCount = sounds.length;
var soundsLoaded = 0;
var snd = {};
var initialLoadingMsg ="L O A D I N G..."; 
var WpText = "WetPussyGames.com presents..."
var logoUp = 600;
var opacityOne = 1;
var opacityTwo = 0;
function loader() {

  if (logoUp > 20) { 
    logoUp -= 20
  } else {
    logoUp = 0
  }

  if (opacityOne > 0.03) {
    opacityOne -= 0.03
  } else {
    opacityTwo += 0.08
    opacityOne = 0
  } 

  ctx.save();
  ctx.globalAlpha = 1;
  ctx.fillStyle="#333333";
  ctx.rect(0, 0, 1600, 1200);
  ctx.fill();
  ctx.restore();

  ctx.save();
  ctx.globalAlpha = opacityTwo;
  ctx.beginPath();
  ctx.drawImage(img.wpg_logo_large, 0, 0, 180, 173, 350, 20, 360, 246);
  ctx.restore();

  if (mouseDown[1] < 305) {
    mouseDown = []
    window.open("http://wetpussygames.com/", '_blank');
  }

  if (mouseOver[1] < 305 || mouseOver[1] > 500) {
    document.body.style.cursor = 'pointer';
  } else {
    document.body.style.cursor = 'default';
  }

  ctx.save();
  ctx.fillStyle = 'white';
  ctx.globalAlpha = opacityOne;
  ctx.font = "60px Arial";
  ctx.fillText(WpText, 150, 280);
  ctx.restore();

  ctx.save();
  ctx.fillStyle="#FFFFFF";
  ctx.font = "95px Arial";
  ctx.lineWidth = 2;

  ctx.fillStyle = 'white';
  ctx.strokeText(" - Kinky Two -", 250, 380+logoUp);
  ctx.fillText(" - Kinky Two -", 250, 380+logoUp);
  ctx.font = "58px Arial";
  ctx.fillText("Comic about a kinky couple", 200, 480+logoUp);
  ctx.restore();

  ctx.beginPath(), ctx.fillStyle="white",	ctx.rect(200, 530+logoUp, 700, 50), ctx.fill();
  ctx.beginPath(), ctx.fillStyle="black", ctx.rect(205, 535+logoUp, imagesLoaded/imagesCount*690 , 40), ctx.fill();
  ctx.font = "20px Arial", ctx.fillStyle="white", ctx.fillText(initialLoadingMsg, 205, 620+logoUp);

  if (imagesLoaded+soundsLoaded == imagesCount+soundsCount) {
    initialLoadingMsg = "P L E A S E   C L I C K / T A P ! !"
    if (mouseDown.length > 0) {
      current = "intro";
    }
  }
};

for (var i = 0; i<imagesCount; i++) {
  var key = images[i].substring(images[i].lastIndexOf("/")+1,images[i].lastIndexOf("."));
  img[key] = new Image();
  img[key].src = images[i];
  img[key].onload = function () {imagesLoaded++};
};
for (var i = 0; i<soundsCount; i++) {
  var key = sounds[i].substring(sounds[i].lastIndexOf("/")+1,sounds[i].lastIndexOf("."));
  snd[key] = new Audio(sounds[i]);
  snd[key].oncanplay = function () {soundsLoaded++};
};

//-------------------------------------- Level -------------------------------------- 
var Level = function Level(title) {
  this.title = title;
  this.isRunning = true;
};
Level.prototype.set = function(to_run) {
  this.title = to_run;
};

Level.prototype.run = function() {
  if (this.isRunning) {
    this.title = eval(this.title)();
  }
};

//-------------------------------------- Button -------------------------------------- 
var Button = function Button(buttonConfigs) {
  this.fillC = "fillC" in buttonConfigs ? buttonConfigs.fillC : "blue";
  this.fillCA = "fillCA" in buttonConfigs ? buttonConfigs.fillCA : "white";
  this.lineW = "lineW" in buttonConfigs ? buttonConfigs.lineW : 1;
  this.lineWA = "lineWA" in buttonConfigs ? buttonConfigs.lineW : 2;
  this.strokeC = "strokeC" in buttonConfigs ? buttonConfigs.strokeC : "black";
  this.strokeCA= "strokeCA" in buttonConfigs ? buttonConfigs.strokeCA : "black";
  this.textC = "textC" in buttonConfigs ? buttonConfigs.textC : "white";
  this.textCA = "textCA" in buttonConfigs ? buttonConfigs.textCA : "black";
  this.paddingLeft = "paddingLeft" in buttonConfigs ? buttonConfigs.paddingLeft : 10;
  this.paddingTop = "paddingTop" in buttonConfigs ? buttonConfigs.paddingTop : 30;
  this.font = "font" in buttonConfigs ? buttonConfigs.font : "30px Arial";
  this.x = "x" in buttonConfigs ? buttonConfigs.x : 50;
  this.y = "y" in buttonConfigs ? buttonConfigs.y : 500;
  this.w = "w" in buttonConfigs ? buttonConfigs.w : 100;
  this.h = "h" in buttonConfigs ? buttonConfigs.h : 50;
  this.text = "text" in buttonConfigs ? buttonConfigs.text : this.text;
  this.newVal = "newVal" in buttonConfigs ? buttonConfigs.newVal : "";
  this.oldVal = "oldVal" in buttonConfigs ? buttonConfigs.oldVal : current;
};

Button.prototype.set = function(buttonConfigs) {

  this.fillC = "fillC" in buttonConfigs ? buttonConfigs.fillC : this.fillC;
  this.fillCA = "fillCA" in buttonConfigs ? buttonConfigs.fillCA : this.fillCA;
  this.lineW = "lineW" in buttonConfigs ? buttonConfigs.lineW : this.lineW;
  this.lineWA = "lineWA" in buttonConfigs ? buttonConfigs.lineW : this.lineWA;
  this.strokeC = "strokeC" in buttonConfigs ? buttonConfigs.strokeC : this.strokeC;
  this.strokeCA= "strokeCA" in buttonConfigs ? buttonConfigs.strokeCA : this.strokeCA;
  this.textC = "textC" in buttonConfigs ? buttonConfigs.textC : this.textC;
  this.textCA = "textCA" in buttonConfigs ? buttonConfigs.textCA : this.textCA;
  this.text = "text" in buttonConfigs ? buttonConfigs.text : this.text;
  this.paddingLeft = "paddingLeft" in buttonConfigs ? buttonConfigs.paddingLeft : this.paddingLeft;
  this.paddingTop = "paddingTop" in buttonConfigs ? buttonConfigs.paddingTop : this.paddingTop;
  this.font = "font" in buttonConfigs ? buttonConfigs.font : this.font;
  this.x = "x" in buttonConfigs ? buttonConfigs.x : this.x;
  this.y = "y" in buttonConfigs ? buttonConfigs.y : this.y;
  this.w = "w" in buttonConfigs ? buttonConfigs.w : this.w;
  this.h = "h" in buttonConfigs ? buttonConfigs.h : this.h;
  this.newVal = "newVal" in buttonConfigs ? buttonConfigs.newVal : this.newVal;
  this.oldVal = "oldVal" in buttonConfigs ? buttonConfigs.oldVal : this.oldVal;
};

Button.prototype.click = function(mouse) {
  if (mouse[0] >= this.x && mouse[0] < this.w+this.x && mouse[1] >= this.y && mouse[1] < this.y+this.h) {
    return this.newVal;
  }	else {
    return this.oldVal;
  }
};

Button.prototype.draw = function (mouseOver) { 
  if (mouseOver[0] >= this.x && mouseOver[0] < this.w+this.x && mouseOver[1] >= this.y && mouseOver[1] < this.y+this.h) {
    ctx.fillStyle = this.fillCA;
    ctx.lineWidth=this.lineWA;
    ctx.strokeStyle = this.strokeCA; 
    ctx.fillRect(this.x, this.y, this.w, this.h);
    ctx.strokeRect(this.x, this.y, this.w, this.h);

    ctx.fillStyle = this.textCA;
    ctx.font = this.font;
    ctx.fillText(this.text, this.x + this.paddingLeft, this.y + this.paddingTop);
  } else {
    ctx.fillStyle = this.fillC;
    ctx.lineWidth=this.lineW;
    ctx.strokeStyle = this.strokeC;
    ctx.fillRect(this.x, this.y, this.w, this.h);
    ctx.strokeRect(this.x, this.y, this.w, this.h);

    ctx.fillStyle = this.textC; 
    ctx.font = this.font;
    ctx.fillText(this.text, this.x + this.paddingLeft, this.y + this.paddingTop);
  };
};
Button.prototype.get = function(attr) {
  output = eval("this."+attr);
  return output;
};

//--- BUBBLE ---
/*
Bubble is used to make dialog texts
*/
var Bubble = function Bubble(bubbleConfigs) {
  this.fillC = "fillC" in bubbleConfigs ? bubbleConfigs.fillC : "white";
  this.textC = "textC" in bubbleConfigs ? bubbleConfigs.textC : "black";
  this.lineW = "lineW" in bubbleConfigs ? bubbleConfigs.lineW : 1;
  this.strokeC = "strokeC" in bubbleConfigs ? bubbleConfigs.strokeC : "black";
  this.x = "x" in bubbleConfigs ? bubbleConfigs.x : 50;
  this.y = "y" in bubbleConfigs ? bubbleConfigs.y : 460;
  this.w = "w" in bubbleConfigs ? bubbleConfigs.w : 700;
  this.h = "h" in bubbleConfigs ? bubbleConfigs.h : 100;
  this.paddingLeft = "paddingLeft" in bubbleConfigs ? bubbleConfigs.paddingLeft : 10;
  this.paddingTop = "paddingTop" in bubbleConfigs ? bubbleConfigs.paddingTop : 10;
  this.font = "font" in bubbleConfigs ? bubbleConfigs.font : "bold 25px Arial";
  this.part = "part" in bubbleConfigs ? bubbleConfigs.part : 0;
  this.textObj = "text" in bubbleConfigs ? bubbleConfigs.text : false;
};

/*
In multimedia/texts/bubble.js is an object that has the same name as the
level function (current) that is using bubble so it must has a prop.level.
It must have a prop.part that that is usually the progress of current level.

bubble.text({level: current, part: 3});

See sources/helper_functions.js function bubbleButton()

initialised in perun_game_specific_defaults.js

var bubble = new Bubble({text: bubbleText});
*/
Bubble.prototype.text = function(props) {
  var selectedLevel = props.level;
  var part = props.part;

  level = this.textObj[selectedLevel];

  this.dialogLength = level.length;

  this.t1 = level[part].lines[0];
  this.t2 = level[part].lines[1];

  this.fillC = "fillC" in level[part].styles ? level[part].styles.fillC : this.fillC;
  this.textC = "textC" in level[part].styles ? level[part].styles.textC : this.textC;
  this.lineW = "lineW" in level[part].styles ? level[part].styles.lineW : this.lineW;
  this.strokeC = "strokeC" in level[part].styles ? level[part].styles.strokeC : this.strokeC;
  this.x = "x" in level[part].styles ? level[part].styles.x : this.x;
  this.y = "y" in level[part].styles ? level[part].styles.y : this.y;
  this.w = "w" in level[part].styles ? level[part].styles.w : this.w;
  this.h = "h" in level[part].styles ? level[part].styles.h : this.h;
  this.paddingLeft = "paddingLeft" in level[part].styles ? level[part].styles.paddingLeft : this.paddingLeft;
  this.paddingTop = "paddingTop" in level[part].styles ? level[part].styles.paddingTop : this.paddingTop;
  this.font = "font" in level[part].styles ? level[part].styles.font : this.font;
};

// Just draw the bubble
// bubble.draw();
Bubble.prototype.draw = function() {
  ctx.fillStyle=this.fillC
  ctx.fillRect(this.x, this.y, this.w, this.h);

  ctx.lineWidth=this.lineW;
  ctx.strokeStyle=this.strokeC;
  ctx.strokeRect(this.x, this.y, this.w, this.h);

  ctx.font = this.font;
  ctx.fillStyle = this.textC;

  var font = this.font.match(/^\d+|\d+\b|\d+(?=\w)/g).map(function (v) {return +v;});
  ctx.fillText(this.t1, this.x+this.paddingLeft, this.y+font[0]+this.paddingTop);
  ctx.fillText(this.t2, this.x+this.paddingLeft, this.y+font[0]+this.h/2+this.paddingTop);
};

// Can return props
// buble.get("fillC") //"blue"
Bubble.prototype.get = function(attr) {
  output = eval("this."+attr);
  return output;
};


//-------------------------------------- BAR -------------------------------------- 
var Bar = function Bar(barConfigs) {
  this.x = "x" in barConfigs ? barConfigs.x : 100;
  this.y = "y" in barConfigs ? barConfigs.y : 500;
  this.w = "w" in barConfigs ? barConfigs.w : 400;
  this.h = "h" in barConfigs ? barConfigs.h : 20;
  this.lineW = "lineW" in barConfigs ? barConfigs.lineW : 1;
  this.strokeC = "strokeC" in barConfigs ? barConfigs.strokeC : "black";
  this.percent = "percent" in barConfigs ? barConfigs.percent : 100;
  this.fillC = "fillC" in barConfigs ? barConfigs.fillC : "red";
  this.text = "text" in barConfigs ? barConfigs.text : false;
  this.textC = "textC" in barConfigs ? barConfigs.textC : "red";
  this.font = "font" in barConfigs ? barConfigs.font : "20px Arial";
};

// change can be positive or negative and it will change percentage
Bar.prototype.changeBy = function (change) {
  // default growing or decrasing rade is 1
  var change = change ? change : -8; 

  if (this.percent + change >= 0 && this.percent + change <= 100 ) {
    this.percent += change;
  }	else {
    if (change > 0) this.percent = 100
    else this.percent = 0
  }

  return this.percent;
};
Bar.prototype.draw = function () {
  this.fillW = this.percent/100*this.w;

  if (this.text) {
    ctx.fillStyle = this.fillC;
    ctx.font = this.font;
    ctx.fillText(this.text, this.x-ctx.measureText(this.text).width, this.y+this.h-this.h/4);
  };

  ctx.fillStyle = this.fillC;
  if (this.fillW >= this.w) ctx.fillRect(this.x, this.y, this.w, this.h)
  else ctx.fillRect(this.x, this.y, this.fillW, this.h);

  ctx.lineWidth=this.lineW;
  ctx.strokeStyle = this.strokeC;
  ctx.strokeRect(this.x, this.y, this.w, this.h);
};

Bar.prototype.set = function(barConfigs) {
  this.x = "x" in barConfigs ? barConfigs.x : this.x;
  this.y = "y" in barConfigs ? barConfigs.y : this.y;
  this.w = "w" in barConfigs ? barConfigs.w : this.w;
  this.h = "h" in barConfigs ? barConfigs.h : this.h;
  this.lineW = "lineW" in barConfigs ? barConfigs.lineW : this.lineW;
  this.strokeC = "strokeC" in barConfigs ? barConfigs.strokeC : this.strokeC;
  this.percent = "percent" in barConfigs ? barConfigs.percent : this.percent;
  this.fillC = "fillC" in barConfigs ? barConfigs.fillC : this.fillC;
  this.text = "text" in barConfigs ? barConfigs.text : this.text;
  this.textC = "textC" in barConfigs ? barConfigs.textC : this.textColor;
  this.font = "font" in barConfigs ? barConfigs.font : this.font;
  this.percent = "percent" in barConfigs ? barConfigs.percent : this.percent;
};
Bar.prototype.get = function(attr) {
  output = eval("this."+attr);
  return output;
};

//-------------------------------------- SCROLL -------------------------------------- 
var Scroll = function Scroll(scrollConfigs) {
  this.x = "x" in scrollConfigs ? scrollConfigs.x : 650;
  this.y = "y" in scrollConfigs ? scrollConfigs.y : 150;
  this.triangleLen = "triangleLen" in scrollConfigs ? scrollConfigs.triangleLen : 40;
  this.bodyLen = "bodyLen" in scrollConfigs ? scrollConfigs.bodyLen : 50;
  this.speed = "speed" in scrollConfigs ? scrollConfigs.speed : 5;
  this.fillC = "fillC" in scrollConfigs ? scrollConfigs.fillC : "red";
  this.fillCA = "fillCA" in scrollConfigs ? scrollConfigs.fillCA : "blue";
  this.strokeC = "strokeC" in scrollConfigs ? scrollConfigs.strokeC : "black";
  this.lineW = "lineW" in scrollConfigs ? scrollConfigs.lineW : 5;
  this.orientation = "orientation" in scrollConfigs ? scrollConfigs.orientation : "vertical";
  this.scrollVal = "scrollVal" in scrollConfigs ? scrollConfigs.scrollVal : 0;
};
Scroll.prototype.getVerticalPoints = function () {
  this.pointOne = [this.x, this.y];
  this.pointTwo = [this.x+this.triangleLen/2, this.y-this.triangleLen];
  this.pointThree = [this.x+this.triangleLen, this.y];

  this.pointFour = [this.x, this.y+this.bodyLen];
  this.pointFive = [this.x+this.triangleLen/2, this.y+this.triangleLen+this.bodyLen];
  this.pointSix = [this.x+this.triangleLen, this.y+this.bodyLen];
};
Scroll.prototype.getHorizontalPoints = function () {
  this.pointOne = [this.x, this.y+this.triangleLen/2];
  this.pointTwo = [this.x+this.triangleLen, this.y];
  this.pointThree = [this.x+this.triangleLen, this.y+this.triangleLen];

  this.pointFour = [this.x+this.bodyLen, this.y+this.triangleLen/2];
  this.pointFive = [this.x+this.bodyLen-this.triangleLen, this.y];
  this.pointSix = [this.x+this.bodyLen-this.triangleLen, this.y+this.triangleLen];
};
Scroll.prototype.draw = function (mouseOver, mouseDown) {
  if (this.orientation == "vertical") this.getVerticalPoints(); 
  else this.getHorizontalPoints(); 

  ctx.strokeStyle = this.strokeC;
  ctx.lineWidth=this.lineW;

  if (mouseDown.length == 0) ctx.fillStyle = this.fillC
  else ctx.fillStyle = this.fillCA

  ctx.beginPath();
  ctx.moveTo(this.pointOne[0], this.pointOne[1]);
  ctx.lineTo(this.pointTwo[0], this.pointTwo[1]);
  ctx.lineTo(this.pointThree[0], this.pointThree[1]);
  ctx.lineTo(this.pointOne[0], this.pointOne[1]);
  ctx.closePath();
  ctx.stroke();

  if (ctx.isPointInPath(mouseOver[0], mouseOver[1])) {
    ctx.fill();
    if (mouseDown.length > 0) this.scrollVal += this.speed;
  };

  ctx.beginPath();
  ctx.moveTo(this.pointFour[0], this.pointFour[1]);
  ctx.lineTo(this.pointFive[0], this.pointFive[1]);
  ctx.lineTo(this.pointSix[0], this.pointSix[1]);
  ctx.lineTo(this.pointFour[0], this.pointFour[1]);
  ctx.closePath();
  ctx.stroke();

  if (ctx.isPointInPath(mouseOver[0], mouseOver[1])) {
    if (mouseDown.length > 0) this.scrollVal -= this.speed;
    ctx.fill();
  }
  return this.scrollVal;
};
Scroll.prototype.set = function (scrollConfigs) {
  this.x = "x" in scrollConfigs ? scrollConfigs.x : this.x;
  this.y = "y" in scrollConfigs ? scrollConfigs.y : this.y;
  this.triangleLen = "triangleLen" in scrollConfigs ? scrollConfigs.triangleLen : this.triangleLen;
  this.bodyLen = "bodyLen" in scrollConfigs ? scrollConfigs.bodyLen : this.bodyLen;
  this.speed = "speed" in scrollConfigs ? scrollConfigs.speed : this.speed;
  this.fillC = "fillC" in scrollConfigs ? scrollConfigs.fillC : this.fillC;
  this.fillCA = "fillCA" in scrollConfigs ? scrollConfigs.fillCA : this.fillCA;
  this.strokeC = "strokeC" in scrollConfigs ? scrollConfigs.strokeC : this.strokeC;
  this.lineW = "lineW" in scrollConfigs ? scrollConfigs.lineW : this.lineW;
  this.orientation = "orientation" in scrollConfigs ? scrollConfigs.orientation : "vertical";
  this.scrollVal = "scrollVal" in scrollConfigs ? scrollConfigs.scrollVal : this.scrollVal;
};
Scroll.prototype.get = function(attr) {
  output = eval("this."+attr);
  return output;
};

//-------------------------------------- FADE TO --------------------------------------
var Fade = function Fade(fadeConfigs) {
  this.color = "color" in fadeConfigs ? fadeConfigs.color : "black";
  this.speed = "speed" in fadeConfigs ? fadeConfigs.speed : 5;
  this.progress = "progress" in fadeConfigs ? fadeConfigs.progress : 0;
};
Fade.prototype.draw = function () {
  this.alfa = this.progress / 100;

  ctx.fillStyle = this.color;
  ctx.save();
  ctx.globalAlpha = this.alfa;
  ctx.fillRect(0, 0, 1152, 648); 
  ctx.restore();
};
Fade.prototype.in = function () {
  if (this.progress-this.speed > 0) this.progress -= this.speed;
  else this.progress = 0;
  this.draw();
};
Fade.prototype.out = function () {
  if (this.progress+this.speed <= 100) this.progress += this.speed;
  else this.progress = 100;
  this.draw();
};
Fade.prototype.set = function () {
  this.color = "color" in fadeConfigs ? fadeConfigs.color : this.color;
  this.speed = "speed" in fadeConfigs ? fadeConfigs.speed : this.speed;
  this.progress = "progress" in fadeConfigs ? fadeConfigs.progress : this.progress;
};
Fade.prototype.get = function(attr) {
  output = eval("this."+attr);
  return output;
};
//-------------------------------------- SPRITE -------------------------------------- 
var Sprite = function Sprite(spriteConfigs) {
  this.img = "img" in spriteConfigs ? spriteConfigs.img : false;
  this.sx = "sx" in spriteConfigs ? spriteConfigs.sx : 0;
  this.sy = "sy" in spriteConfigs ? spriteConfigs.sy : 0;
  this.sw = "sw" in spriteConfigs ? spriteConfigs.sw : 0;
  this.sh = "sh" in spriteConfigs ? spriteConfigs.sh : 0;
  this.dx = "dx" in spriteConfigs ? spriteConfigs.dx : 0;
  this.dy = "dy" in spriteConfigs ? spriteConfigs.dy : 0;
  this.dw = "dw" in spriteConfigs ? spriteConfigs.dw : this.sw;
  this.dh = "dh" in spriteConfigs ? spriteConfigs.dh : this.sh;
  this.alfa = "alfa" in spriteConfigs ? spriteConfigs.alfa : 1;
  if (("scale" in spriteConfigs) && spriteConfigs.scale) {
    this.dw = this.dw * spriteConfigs.scale;
    this.dh = this.dh * spriteConfigs.scale;
  };
};
Sprite.prototype.animate = function (animationConfigs) { //num) { 
  this.num = "num" in animationConfigs ? animationConfigs.num : 0;
  this.perSec = "perSec" in animationConfigs ? animationConfigs.perSec : 1;
  speed = fps / this.perSec / this.num;
  if (underSec%Math.round(speed)==0) this.sx += this.sw
  if (this.sx == this.sw*this.num) {
    this.sx = 0;
    return false;
  } else {
    return true;
  }
};
Sprite.prototype.draw = function() {
  ctx.save();
  ctx.globalAlpha = this.alfa  
  ctx.drawImage(this.img, this.sx, this.sy, this.sw, this.sh, this.dx, this.dy, this.dw, this.dh);
  ctx.restore();
};
Sprite.prototype.set = function(spriteConfigs) {
  this.img = "img" in spriteConfigs ? spriteConfigs.img : this.img;
  this.sx = "sx" in spriteConfigs ? spriteConfigs.sx : this.sx;
  this.sy = "sy" in spriteConfigs ? spriteConfigs.sy : this.sy;
  this.sw = "sw" in spriteConfigs ? spriteConfigs.sw : this.sw;
  this.sh = "sh" in spriteConfigs ? spriteConfigs.sh : this.sh;
  this.dx = "dx" in spriteConfigs ? spriteConfigs.dx : this.dx;
  this.dy = "dy" in spriteConfigs ? spriteConfigs.dy : this.dy;
  this.dw = "dw" in spriteConfigs ? spriteConfigs.dw : this.dw;
  this.dh = "dh" in spriteConfigs ? spriteConfigs.dh : this.dh;
  this.alfa = "alfa" in spriteConfigs ? spriteConfigs.alfa : this.alfa;
  if ("scale" in spriteConfigs) {
    if (spriteConfigs.scale) {
      this.dw = this.dw * spriteConfigs.scale;
      this.dh = this.dw * spriteConfigs.scale;
    }
  };

};
Sprite.prototype.get = function(attr) {
  output = eval("this."+attr);
  return output;
};

Sprite.prototype.move = function (speed, direction, autoRestore) {
  this.speed = speed

  if (direction.toLowerCase().replace(" ", "") == "left>right") {
    this.dx += this.speed
    if (autoRestore) {
      if (this.dx+this.dw < 0) this.dx=this.dw+10
      return this.dx 
    } else {return this.dx }
  } else if (direction.toLowerCase().replace(" ", "") == "right>left") {
    this.dx -= this.speed
    if (autoRestore) {
      if (this.dx+this.dw < 0) this.dx=this.dw-10
      return this.dx 
    } else {return this.dx }

  } else if (direction.toLowerCase().replace(" ", "") == "up>down") {
    this.dy += this.speed
    if (autoRestore) {
      if (this.dy > this.dh) this.dy=10-this.dh
      return this.dy
    } else {return this.dx }
  } else if (direction.toLowerCase().replace(" ", "") == "down>up") { 

  } else {
    console.log('Speed must be a number or an array of numbers if more grounds.') 
    console.log('Valid directions are "left>right", "right>left", "up>down", "down>up" (valid also "left> Right")')
  }
}

//TODO seperate???
//TODO all springConfigs and other replace with configs
//-------------------------------------- Jump and Run character -------------------------------------- 
var JarChar = function JarChar(configs) {
  this.img = "img" in configs ? configs.img : false;
  this.sx = "sx" in configs ? configs.sx : 0;
  this.sy = "sy" in configs ? configs.sy : 0;
  this.sw = "sw" in configs ? configs.sw : 0;
  this.sh = "sh" in configs ? configs.sh : 0;
  this.dx = "dx" in configs ? configs.dx : 0;
  this.dy = "dy" in configs ? configs.dy : 0;
  this.dw = "dw" in configs ? configs.dw : this.sw;
  this.dh = "dh" in configs ? configs.dh : this.sh;
  this.scale = "scale" in configs ? configs.scale : null;
  this.alfa = "alfa" in configs ? configs.alfa : 1;
  this.spriteMap = "spriteMap" in configs ? configs.spriteMap : [];

  this.orientationOne = "orientationOne" in configs ? configs.orientationOne : 39;
  this.orientationTwo = "orientationTwo" in configs ? configs.orientationTwo : 37;
  this.jump = "jump" in configs ? configs.jump : this.jump;

  // when to switch to image part for the opposite side
  this.changeOrientationBy = "changeOrientationBy" in configs ? configs.changeOrientationBy : 0;

  this.num = "num" in configs ? configs.num : 0;
  this.perSec = "perSec" in configs ? configs.perSec : 1;

  // initialize all sprites needed
  // each of them is a part of the sprite.png
  this.allSprites = [];

  // active will be animated and drawn
  this.active = {}; 

  // the last initial sprite is active on keyup
  this.initial = {}; 
  for (var i=0; i<this.spriteMap.length; i++) {
    var keyObj = this.spriteMap[i];
    var name = "name" in keyObj ? keyObj.name : "";
    var position = "position" in keyObj ? keyObj.position : false;
    var activeOnKeys = "activeOnKeys" in keyObj ? keyObj.activeOnKeys : false;
    var isAnimated = "isAnimated" in keyObj ? keyObj.isAnimated : true;
    var isInitial = "initial" in keyObj ? keyObj.initial : false;
    var trigger = "trigger" in keyObj ? keyObj.trigger : false;
    var duration = "duration" in keyObj ? keyObj.duration : null;

    // set all sprite 
    this.allSprites.push({
      sprite: new Sprite({
        img: this.img, 
        sx: this.sx, sy: this.sy+this.sh*position, sw: this.sw, sh: this.sh, 
        dx: this.dx, dy: this.dy, dw: this.dw, dh: this.dh
      }),
      name: name,
      activeOnKeys: activeOnKeys,
      isAnimated: isAnimated,
      orientation: this.orientationOne,
      trigger: trigger,
      duration: duration,
    });

    // set initial sprite 
    if (isInitial) {
      this.active = this.initial = {
        sprite: new Sprite({
          img: this.img, 
          sx: this.sx, sy: this.sy+this.sh*position, sw: this.sw, sh: this.sh, 
          dx: this.dx, dy: this.dy, dw: this.dw, dh: this.dh
        }),
        name: name,
        activeOnKeys: activeOnKeys,
        isAnimated: isAnimated,
        orientation: this.orientationOne,
        trigger: trigger,
        duration: duration
      };
    }
  };
}

//stopper that temporarly stops the change
var jarCharActionStopper = {active: false, duration: 0};

// set the active Sprite and drow it 
JarChar.prototype.draw = function(configs) {
  this.stopAnimation = "stopAnimation" in configs ? configs.stopAnimation : false;
  for (var i=0; i<this.allSprites.length; i++) {
    if (!isEmpty(keysPressed)) {
      // change orientation characters orientation
      if (keysPressed[this.orientationOne] ) {
        // if the key is pressed and the orientation should change
        if (this.orientationOne != this.allSprites[i].orientation) {
          // set the new sy of the sprate
          // first half of the spride (horizontaly) is one orientation
          // and second half is the oher
          // (for exampel first is right, second is left)
          this.allSprites[i].sprite.set({
            sy: this.allSprites[i].sprite.get("sy")-this.changeOrientationBy,
            sx: this.allSprites[i].sprite.get("sx"),
            sh: this.allSprites[i].sprite.get("sh"),
            sw: this.allSprites[i].sprite.get("sw"),
            dx: this.allSprites[i].sprite.get("dx"),
            dy: this.allSprites[i].sprite.get("dy"),
            dh: this.allSprites[i].sprite.get("dh"),
            dw: this.allSprites[i].sprite.get("dw"),
            alfa: this.allSprites[i].sprite.get("alfa"),
          });
          this.allSprites[i].orientation = this.orientationOne;
        }

        // also change the orientation of the initial image
        if (this.orientationOne != this.initial.orientation) {
          this.initial.sprite.set({
            sy: this.initial.sprite.get("sy")-this.changeOrientationBy,
            sx: this.initial.sprite.get("sx"),
            sh: this.initial.sprite.get("sh"),
            sw: this.initial.sprite.get("sw"),
            dx: this.initial.sprite.get("dx"),
            dy: this.initial.sprite.get("dy"),
            dh: this.initial.sprite.get("dh"),
            dw: this.initial.sprite.get("dw"),
            alfa: this.initial.sprite.get("alfa"),
          });

          // set current orientation so this if won't pass until 
          // orientation is changed by the other orientation button
          this.initial.orientation = this.orientationOne;
        }
      } else if (keysPressed[this.orientationTwo] ) {
        // same as if abow but for the other side
        if (this.orientationTwo != this.allSprites[i].orientation) {
          this.allSprites[i].sprite.set({
            sy: this.allSprites[i].sprite.get("sy")+this.changeOrientationBy,
            sx: this.allSprites[i].sprite.get("sx"),
            sh: this.allSprites[i].sprite.get("sh"),
            sw: this.allSprites[i].sprite.get("sw"),
            dx: this.allSprites[i].sprite.get("dx"),
            dy: this.allSprites[i].sprite.get("dy"),
            dh: this.allSprites[i].sprite.get("dh"),
            dw: this.allSprites[i].sprite.get("dw"),
            alfa: this.allSprites[i].sprite.get("alfa"),
          });
          this.allSprites[i].orientation = this.orientationTwo;
        }

        if (this.orientationTwo != this.initial.orientation) {
          this.initial.sprite.set({
            sy: this.initial.sprite.get("sy")+this.changeOrientationBy,
            sx: this.initial.sprite.get("sx"),
            sh: this.initial.sprite.get("sh"),
            sw: this.initial.sprite.get("sw"),
            dx: this.initial.sprite.get("dx"),
            dy: this.initial.sprite.get("dy"),
            dh: this.initial.sprite.get("dh"),
            dw: this.initial.sprite.get("dw"),
            alfa: this.initial.sprite.get("alfa"),
          });
          this.initial.orientation = this.orientationTwo;
        }
      }

      // change active sprite by the pressed keys unless stopper is active
      for (var k=0; k<this.allSprites[i].activeOnKeys.length; k++) {
        if (this.active.name != this.allSprites[i].name) {
          if (keysPressed[this.allSprites[i].activeOnKeys[k]]) {
            if (!jarCharActionStopper.active) {
              this.active = this.allSprites[i];
            };
          }; 
        }
      }

    } else {
      // when no key pressed than drow initial sprite unless stopper is active
      if (!jarCharActionStopper.active) {
        this.active = this.initial;
      }
    }

    // when trigger condition is true - for example falling
    if (this.allSprites[i].trigger) {
      this.active = this.allSprites[i];
    }
  }

  // if the active sprite shoudl be animated
  if (this.active.isAnimated) {
    // usualy ground.move can stop the animation
    if (!this.stopAnimation) {
      this.active.sprite.animate({num: this.num, perSec: this.perSec});
    } else {
      this.active = this.initial;
    }
  }

  this.active.sprite.draw();

  // jarCharActionDuration will stop the change until its at 0
  if (this.active.duration && !jarCharActionStopper.active) {
    jarCharActionStopper.duration = this.active.duration;
  }

  // this.stopper is used to stop gravitation
  if (jarCharActionStopper.duration > 0) {
    jarCharActionStopper.active = true;
    this.stopper = true;

    // if the jumping sprite is active and the char has the jump height
    if (this.active.name=="jump" && this.jump) {
      if (soundOn) snd.jump.play();
      this.dy -= this.jump
    }

    jarCharActionStopper.duration--;
  } else {
    jarCharActionStopper.active = false;
    this.stopper = false;
  }
};

JarChar.prototype.gravitation = function(props) {
  var speed = "speed" in props ? props.speed : 10;
  var groundDy = "groundDy" in props ? props.groundDy : 500;
  var objectDy = this.dy;
  var objectDh = this.dh;
  var allSprites = this.allSprites;
  var falling = false;

  // if object didn't touched the ground and it's not jumping
  if (objectDy+objectDh <= groundDy && !this.stopper) {
    // find sprite that is triggerd by gravity
    for (var i = 0; i < allSprites.length; i++) {
      var sprite = allSprites[i];
      // if it's false 
      if (typeof sprite.trigger == "boolean" && !sprite.trigger ) {
        //... make it true
        allSprites[i].trigger = true;
      }
      // move the object to the ground
      this.dy = objectDy + speed;
      sprite.sprite.set({dy: this.dy})
    }
    falling = true;
  } else {
    // find sprite that is triggerd by gravity
    for (var i = 0; i < allSprites.length; i++) {
      var sprite = allSprites[i];
      // if it's true
      if (typeof sprite.trigger == "boolean" && sprite.trigger ) {
        //... make it false
        allSprites[i].trigger = false;
      }
      // move the object to the ground
      sprite.sprite.set({dy: this.dy})
    }
    falling = false;
  }

  if (!falling && (keysPressed[39] || keysPressed[37])) {
    if (soundOn) snd.walk.play();
  }

  // also update initial sprite
  this.initial.sprite.set({dy: this.dy})
  return falling;
}; 

//only returning hitbox
JarChar.prototype.position = function(configs) {
  var charHitbox = {
    x: this.dx,
    y: this.dy,
    w: this.dw,
    h: this.dh
  }

  return charHitbox;
}

JarChar.prototype.set = function(configs) {
  this.img = "img" in configs ? configs.img : this.img;
  this.sx = "sx" in configs ? configs.sx : this.sx;
  this.sy = "sy" in configs ? configs.sy : this.sy;
  this.sw = "sw" in configs ? configs.sw : this.sw;
  this.sh = "sh" in configs ? configs.sh : this.sh;
  this.dx = "dx" in configs ? configs.dx : this.dx;
  this.dy = "dy" in configs ? configs.dy : this.dy;
  this.dw = "dw" in configs ? configs.dw : this.dw;
  this.dh = "dh" in configs ? configs.dh : this.dh;
  this.scale = "scale" in configs ? configs.scale : this.scale;
  this.alfa = "alfa" in configs ? configs.alfa : this.alfa;
  //TODO make set for each item in array
  this.spriteMap = "spriteMap" in configs ? configs.spriteMap : this.spriteMap;

  this.orientationOne = "orientationOne" in configs ? configs.orientationOne : this.orientationOne;
  this.orientationTwo = "orientationTwo" in configs ? configs.orientationTwo : this.orientationTwo;
  this.changeOrientationBy = "changeOrientationBy" in configs ? configs.changeOrientationBy : this.changeOrientationBy;

  this.num = "num" in configs ? configs.num : this.num;
  this.perSec = "perSec" in configs ? configs.perSec : this.perSec;

  this.allSprites = [];
  for (var i=0; i<this.spriteMap.length; i++) {
    var keyObj = this.spriteMap[i];
    var name = "name" in keyObj ? keyObj.name : "";
    var position = "position" in keyObj ? keyObj.position : false;
    var activeOnKeys = "activeOnKeys" in keyObj ? keyObj.activeOnKeys : false;
    var isAnimated = "isAnimated" in keyObj ? keyObj.isAnimated : true;
    var isInitial = "initial" in keyObj ? keyObj.initial : false;
    var trigger = "trigger" in keyObj ? keyObj.trigger : null;

    // set all sprite 
    this.allSprites.push({
      sprite: new Sprite({
        img: this.img, 
        sx: this.sx, sy: this.sy+this.sh*position, sw: this.sw, sh: this.sh, 
        dx: this.dx, dy: this.dy, dw: this.dw, dh: this.dh
      }),
      name: name,
      activeOnKeys: activeOnKeys,
      isAnimated: isAnimated,
      orientation: this.orientationOne,
      trigger: trigger,
      duration: jarCharActionStopper.duration
    });

    // set initial sprite 
    if (isInitial) {
      this.active = this.initial = {
        sprite: new Sprite({
          img: this.img, 
          sx: this.sx, sy: this.sy+this.sh*position, sw: this.sw, sh: this.sh, 
          dx: this.dx, dy: this.dy, dw: this.dw, dh: this.dh
        }),
        name: name,
        activeOnKeys: activeOnKeys,
        isAnimated: isAnimated,
        orientation: this.orientationOne,
        trigger: trigger,
        duration: jarCharActionStopper.duration
      };
    }
  }
};

JarChar.prototype.get = function(attr) {
  output = eval("this."+attr);
  return output;
};

//-------------------------------------- GROUND -------------------------------------- 
var Ground = function Ground(configs) {
  this.img = "img" in configs ? configs.img : false;
  this.sx = "sx" in configs ? configs.sx : 0;
  this.sy = "sy" in configs ? configs.sy : 0;
  this.sw = "sw" in configs ? configs.sw : 0;
  this.sh = "sh" in configs ? configs.sh : 0;
  this.dx = "dx" in configs ? configs.dx : 0;
  this.dy = "dy" in configs ? configs.dy : 0;
  this.dw = "dw" in configs ? configs.dw : this.sw;
  this.dh = "dh" in configs ? configs.dh : this.sh;
  this.scale = "scale" in configs ? configs.scale : null;
  this.alfa = "alfa" in configs ? configs.alfa : 1;

  this.moveToLeft = "moveToLeft" in configs ? configs.moveToLeft : null;
  this.moveToRight = "moveToRight" in configs ? configs.moveToRight : null;
  this.moveSpeed = "moveSpeed" in configs ? configs.moveSpeed : null;
  this.startAt = "startAt" in configs ? configs.startAt : null;
  this.endAt = "endAt" in configs ? configs.endAt : null;
  this.barriers = "barriers" in configs ? configs.barriers : [];
};

// traps are holes or landmines
// by they name they return different values
// barriers are positions of the traps
Ground.prototype.trap = function (config) {
  var overTrap = false;
  for (var i=0; i < this.barriers.length; i++) {
    var barrier = this.barriers[i];
    if (this.dx <= barrier.startAt && this.dx > barrier.endAt) {
      overTrap = true;
    }
  }

  if (overTrap) {
    if (barrier.name == "fall") return config.triggeredValue
  } else {
    return config.untriggeredValue
  }

};

//move ground depending on pressed keys - keys are opposite of char direction
Ground.prototype.move = function() {
  if (keysPressed) {
    if (keysPressed[this.moveToLeft]) {
      if (this.dx - this.moveSpeed >= this.endAt) {
        this.dx -= this.moveSpeed;
        return false;
      } else {
        return true;
      }
    } else if (keysPressed[this.moveToRight]) {
      if (this.dx + this.moveSpeed <= this.startAt) {
        this.dx += this.moveSpeed;
        return false
      } else {
        return true
      }
    }
  }
};

Ground.prototype.draw = function() {
  ctx.save();
  ctx.globalAlpha = this.alfa  
  ctx.drawImage(this.img, this.sx, this.sy, this.sw, this.sh, this.dx, this.dy, this.dw, this.dh);
  ctx.restore();
};

Ground.prototype.set = function(configs) {
  this.img = "img" in configs ? configs.img : this.img;
  this.sx = "sx" in configs ? configs.sx : this.sx;
  this.sy = "sy" in configs ? configs.sy : this.sy;
  this.sw = "sw" in configs ? configs.sw : this.sw;
  this.sh = "sh" in configs ? configs.sh : this.sh;
  this.dx = "dx" in configs ? configs.dx : this.dx;
  this.dy = "dy" in configs ? configs.dy : this.dy;
  this.dw = "dw" in configs ? configs.dw : this.dw;
  this.dh = "dh" in configs ? configs.dh : this.dh;
  this.scale = "scale" in configs ? configs.scale : this.scale;
  this.alfa = "alfa" in configs ? configs.alfa : this.alfa;

  this.moveToLeft = "moveToLeft" in configs ? configs.moveToLeft : this.moveToLeft;
  this.moveToRight = "moveToRight" in configs ? configs.moveToRight : this.moveToRight;
  this.moveSpeed = "moveSpeed" in configs ? configs.moveSpeed : this.moveSpeed;
  this.startAt = "startAt" in configs ? configs.startAt : this.startAt;
  this.endAt = "endAt" in configs ? configs.endAt : this.endAt;
  this.barriers = "barriers" in configs ? configs.barriers : [];
};

Ground.prototype.get = function(attr) {
  output = eval("this."+attr);
  return output;
};

//-------------------------------------- ENEMY -------------------------------------- 
// Enemy takes the usual configs as sprites but it has: 
// isAnimated, 
// sprites, - all sprites with configs 
// configas are added to initializator,
// isVisible, - is the enemy visible
// isInitial, - the sprite that will be first active
//
//TODO 
// char has a hitbox
// enemy is returning the position
var Enemy = function Enemy(configs) {
  this.enemySprites = [];
  this.active = null;

  // need for turning point in move
  this.distance = 0;
  this.speedCorrector = 1;

  if (("sprites" in configs) && configs.sprites.length > 0) {
    for (var i=0; i < configs.sprites.length; i++) {
      var spriteConfigs = configs.sprites[i];

      var img = "img" in spriteConfigs ? spriteConfigs.img : false;
      var sx = "sx" in spriteConfigs ? spriteConfigs.sx : 0;
      var sy = "sy" in spriteConfigs ? spriteConfigs.sy : 0;
      var sw = "sw" in spriteConfigs ? spriteConfigs.sw : 0;
      var sh = "sh" in spriteConfigs ? spriteConfigs.sh : 0;
      var dx = "dx" in spriteConfigs ? spriteConfigs.dx : 0;
      var dy = "dy" in spriteConfigs ? spriteConfigs.dy : 0;
      var dw = "dw" in spriteConfigs ? spriteConfigs.dw : sw;
      var dh = "dh" in spriteConfigs ? spriteConfigs.dh : sh;
      var scale = "scale" in spriteConfigs ? spriteConfigs.scale : null;
      var alfa = "alfa" in spriteConfigs ? spriteConfigs.alfa : 1;
      var num = "num" in spriteConfigs ? spriteConfigs.num : 0;
      var perSec = "perSec" in spriteConfigs ? spriteConfigs.perSec : 1;
      var isAnimated = "isAnimated" in spriteConfigs ? spriteConfigs.isAnimated : true;
      var isVisible = "isVisible" in spriteConfigs ? spriteConfigs.isVisible : true;
      var isInitial = "isInitial" in spriteConfigs ? spriteConfigs.isInitial : false;
      var name = "name" in spriteConfigs ? spriteConfigs.name : true;

      // make the enemey sprite (for example direction)
      var enemy = {
        name: name,
        isAnimated: isAnimated,
        num: num,
        perSec: perSec,
        isVisible: isVisible,
        sprite: new Sprite({
          img: img, 
          sx: sx, sy: sy, sw: sw, sh: sh, 
          dx: dx, dy: dy, dw: dw, dh: dh,
          scale: scale, alfa: alfa
        })
      }

      // and push it to enemy (all image from the enemy)
      this.enemySprites.push(enemy)

      // if this sprite is active than add it to active
      if (isInitial) { this.active = enemy}
    }
  }
};

Enemy.prototype.draw = function(configs) {
  if (this.active) {
    if (this.active.isAnimated) {
      this.active.sprite.animate({
        num: this.active.num, perSec: this.active.perSec
      });
    }

    if (this.active.isVisible) {
      this.active.sprite.draw();
    }
  }
};

//helper for move
function turnEnemyAround(active, enemySprites, direction) {
  for (var i=0; i < enemySprites.length; i++) {
    if (enemySprites[i].name == direction) {
      active = enemySprites[i];
    }
  }
  return active
}

Enemy.prototype.move = function(configs) {
  var speed = "speed" in configs ? configs.speed : null;
  var turnAroundAt = "turnAroundAt" in configs ? configs.turnAroundAt : null;

  // take sprites coordinates
  var x = this.active.sprite.get("dx");
  var y = this.active.sprite.get("dy");
  var w = this.active.sprite.get("dw"); 
  var h = this.active.sprite.get("dh");

  if (speed) {
    // run at some speed
    x += speed * this.speedCorrector;
    this.distance += speed * this.speedCorrector;

    // change direction 
    if (turnAroundAt && 
      (this.distance >= turnAroundAt || this.distance <= 0)) {
      this.speedCorrector *= -1;

      //change sprite with helper
      var newDirection = this.active.name == "toRight" ? "toLeft" : "toRight"
      this.active=turnEnemyAround(this.active,this.enemySprites,newDirection);
    }

    this.active.sprite.set({dx: x});
  } 

  var hitbox = { x: x, y: y, w: w, h: h, distance: this.distance}
  return hitbox;
}

//moveFor is ground moveSpeed and should be added when the lvlDistance 
//has changed
Enemy.prototype.moveWithGround = function (configs) {
  var moveFor = "moveFor" in configs ? configs.moveFor : null;
  this.active.sprite.set({dx: this.active.sprite.get("dx")+moveFor});
}

Enemy.prototype.gravitation = function (props) {
  var speed = "speed" in props ? props.speed : 10;
  var groundDy = "groundDy" in props ? props.groundDy : 500;
  var objectDy = this.active.sprite.get("dy");
  var objectDh = this.active.sprite.get("dh");

  // if object didn't touched the ground
  if (objectDy+objectDh < groundDy) {
    var y = objectDy + speed;
    this.active.sprite.set({dy: y});
  } else {
    this.active.sprite.set({dy: groundDy-objectDh});
  }
} 

Enemy.prototype.set = function(configs) {
  //TODO NOT WORKING
  this.img = "img" in configs ? configs.img : this.img;
  this.sx = "sx" in configs ? configs.sx : this.sx;
  this.sy = "sy" in configs ? configs.sy : this.sy;
  this.sw = "sw" in configs ? configs.sw : this.sw;
  this.sh = "sh" in configs ? configs.sh : this.sh;
  this.dx = "dx" in configs ? configs.dx : this.dx;
  this.dy = "dy" in configs ? configs.dy : this.dy;
  this.dw = "dw" in configs ? configs.dw : this.dw;
  this.dh = "dh" in configs ? configs.dh : this.dh;
  this.scale = "scale" in configs ? configs.scale : this.scale;
  this.alfa = "alfa" in configs ? configs.alfa : this.alfa;
  this.num = "num" in configs ? configs.num : this.num;
  this.perSec = "perSec" in configs ? configs.perSec : this.perSec;
  this.isAnimated = "isAnimated" in configs ? configs.isAnimated : this.isAnimated;
  this.isVisible = "isVisible" in configs ? configs.isVisible : this.isVisible;
  this.isInitial = "isInitial" in configs ? configs.isInitial : this.isInitial;
};

Enemy.prototype.get = function(attr) {
  output = eval("this."+attr);
  return output;
};

//-------------------------------------- Game runner -------------------------------------- 
var currentLevel = new Level(current);

/* levelStates = {
  firstLevel: {
    immutableState: function that returns game props - can't be changed,
    mutableState: object that is at the beggin of the level same as 
      immutableState but it will change during the level - at the end
      it will be reset - function resetMutableState()
    }
}
*/
var levelStates = {};
// when the level is over this will reset it's mutable state
function resetMutableState(stateName) {
  levelStates[stateName].mutable = levelStates[stateName].immutable();
}; 

//keys -> finished: boolean, unlocked: boolean
var playableLevels = {};
var playableCutsceenes = {};

setInterval(function(){
  ctx.clearRect(0, 0, canvas.width, canvas.height);

  checkIfIdle()
  currentLevel.set(current);
  currentLevel.run();
  mouse=[];

  underSec++;
  if (underSec >= fps) {underSec = 0, levelSec++}
}, 1000/fps);
