var canEndCountdown = 2;
var timeBetweenClicks = 2000;
// --- intro ---
levelStates.intro= {
  immutable: function() {
    return ({
      progress: 0, spraying: 60, crystal_sound: true,
      stopper: 30,
      spray: new Sprite({
        img: img.spray_sprite, 
        sw: 265, sh: 233, dx: 270, dy: 134, dw: 530, dh: 466
      }) 
    });
  }
}
levelStates.intro.mutable = levelStates.intro.immutable();
function intro() {
  var level = levelStates.intro.mutable;
  if (level.progress == 0) {
    ctx.drawImage(img.cover, 0, 0, 1152, 648, 0, 0, 1152, 648);
    fade.in();
    if (fade.get("progress")==0) level.progress = 1
  } else if (level.progress >= 1 && level.progress < 2) {
    ctx.drawImage(img.cover, 0, 0, 1152, 648, 0, 0, 1152, 648);
  }
  if (level.stopper <= 0 && mouseDown.length > 0) { 
    resetMutableState(current);
    current = "pageOne";
  };
  if (level.stopper > 0) { level.stopper-- };
  helpClick(450, 450);
  //  helpHold(400, 200);
  soundSwitch();
  linker({x: 10, y: 10, w: 142*1.2, h: 157*1.2});
  snd.disco.pause();
  bgMusic();
};
levelStates.pageOne = { immutable: function() {
  return({ 
    imageFadeSpeed: 0.1,
    imageOne: new Sprite({ img: img.page_one_one, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 1,
    }),
    imageTwo: new Sprite({ img: img.page_one_two, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageThree: new Sprite({ img: img.page_one_three, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageFour: new Sprite({ img: img.page_one_four, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageFive: new Sprite({ img: img.page_one_five, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageSix: new Sprite({ img: img.page_one_six, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageBgOne: new Sprite({ img: img.page_one_bg, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 1
    }),
    imageBgTwo: new Sprite({ img: img.page_one_bg, 
      sy: 1296, sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 1
    }),
    imageAnimation: new Sprite({ img: img.page_one_animation, 
      sw: 720, sh: 1296, dw: 360, dh: 648, alfa: 1, dx: 220
    }),
    progress: 0,
    disableClick: false,
    drawOne: true,
    drawTwo: false,
    drawThree: false,
    drawFour: false,
    drawFive: false,
    drawSix: false,
  });
}
};
levelStates.pageOne.mutable = levelStates.pageOne.immutable();
function pageOne() {
  if (soundOn) { 
    snd.shower.play(); 
  } else {
    snd.shower.pause(); 
  }

  var level = levelStates.pageOne.mutable;
  // navigate through level
  if (!level.disableClick && mouseDown.length > 0) { 
    level.progress++;
    level.disableClick=true;
    if (!level.drawFour) {
      mouseDown=[];
    }
  };
  if (level.disableClick) { 
    // small pause bf can click again
    setTimeout(function(){ level.disableClick = false }, timeBetweenClicks);
  }
  if (level.drawOne) {
    var alfaOne = level.imageOne.get("alfa");
    if (alfaOne<1) { 
      level.imageOne.set({alfa: alfaOne + level.imageFadeSpeed }) 
      level.imageBgTwo.set({alfa: alfaOne + level.imageFadeSpeed }) 
      level.imageBgOne.set({alfa: alfaOne + level.imageFadeSpeed }) 
      level.imageAnimation.set({alfa: alfaOne + level.imageFadeSpeed }) 
    };
    level.imageBgTwo.draw();
    level.imageAnimation.animate({num: 4})
    level.imageAnimation.draw();
    level.imageBgOne.draw();
    level.imageOne.draw();
  };
  if (level.drawThree) {
    var alfaThree = level.imageThree.get("alfa");
    if (alfaThree<1) { 
      level.imageThree.set({alfa: alfaThree + level.imageFadeSpeed }) 
    };
    level.imageThree.draw();
  };
  if (level.drawTwo) {
    var alfaTwo = level.imageTwo.get("alfa");
    if (alfaTwo<1) { level.imageTwo.set({alfa: alfaTwo + level.imageFadeSpeed }) };
    level.imageTwo.draw();
  };
  if (level.drawThree) {
    var alfaThree = level.imageThree.get("alfa");
    if (alfaThree<1) { level.imageThree.set({alfa: alfaThree + level.imageFadeSpeed }) };
    level.imageThree.draw();
  };
  if (level.drawFour) {
    var alfaFour = level.imageFour.get("alfa");
    if (alfaFour<1) { level.imageFour.set({alfa: alfaFour + level.imageFadeSpeed }) };
    level.imageFour.draw();
  };
  if (level.drawFive) {
    var alfaFive = level.imageFive.get("alfa");
    if (alfaFive<1) { level.imageFive.set({alfa: alfaFive + level.imageFadeSpeed }) };
    level.imageFive.draw();
  };
  if (level.drawSix) {
    var alfaSix = level.imageSix.get("alfa");
    if (alfaSix<1) { level.imageSix.set({alfa: alfaSix + level.imageFadeSpeed }) };
    level.imageSix.draw();
  };
  // draw images
  if (level.progress == 0) {
    fade.in();
    if (fade.get("progress")==0) level.progress = 1
  } else if (level.progress==1) {
    level.drawTwo = true;
  } else if (level.progress==2) {
    level.drawThree = true;
  } else if (level.progress==3) {
    level.drawFour = true;
  } else if (level.progress==4) {
    level.drawFive = true;
  } else if (level.progress==5) {
    level.drawSix = true;
  } else if (level.progress>=6) {
    fade.out();
    if (fade.get("progress")==100) {
      snd.shower.pause();
      resetMutableState(current);
      current="pageTwo";
    }
  }
  helpClick(450, 450);
  linker({x: 0, y: 0});
  soundSwitch();
  bgMusic();
  snd.disco.pause();
};
levelStates.pageTwo = { immutable: function() {
  return({ 
    imageFadeSpeed: 0.1,
    imageOne: new Sprite({ img: img.page_two_one, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0,
    }),
    imageTwo: new Sprite({ img: img.page_two_two, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageThree: new Sprite({ img: img.page_two_three, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageFour: new Sprite({ img: img.page_two_four, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageFive: new Sprite({ img: img.page_two_five, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageSix: new Sprite({ img: img.page_two_six, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageSeven: new Sprite({ img: img.page_two_seven, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    progress: 0,
    disableClick: false,
    drawOne: true,
    drawTwo: false,
    drawThree: false,
    drawFour: false,
    drawFive: false,
    drawSix: false,
    drawSeven: false,
  });
}
};
levelStates.pageTwo.mutable = levelStates.pageTwo.immutable();
function pageTwo() {
  var level = levelStates.pageTwo.mutable;
  // navigate through level
  if (!level.disableClick && mouseDown.length > 0) { 
    level.progress++;
    level.disableClick=true;
    if (!level.drawFour) {
      mouseDown=[];
    }
  };
  if (level.disableClick) { 
    // small pause bf can click again
    setTimeout(function(){ level.disableClick = false }, timeBetweenClicks);
  }
  if (level.drawOne) {
    var alfaOne = level.imageOne.get("alfa");
    if (alfaOne<1) { 
      level.imageOne.set({alfa: alfaOne + level.imageFadeSpeed }) 
    };
    level.imageOne.draw();
  };
  if (level.drawTwo) {
    var alfaTwo = level.imageTwo.get("alfa");
    if (alfaTwo<1) { level.imageTwo.set({alfa: alfaTwo + level.imageFadeSpeed }) };
    level.imageTwo.draw();
  };
  if (level.drawThree) {
    var alfaThree = level.imageThree.get("alfa");
    if (alfaThree<1) { level.imageThree.set({alfa: alfaThree + level.imageFadeSpeed }) };
    level.imageThree.draw();
  };
  if (level.drawFour) {
    var alfaFour = level.imageFour.get("alfa");
    if (alfaFour<1) { level.imageFour.set({alfa: alfaFour + level.imageFadeSpeed }) };
    level.imageFour.draw();
  };
  if (level.drawFive) {
    var alfaFive = level.imageFive.get("alfa");
    if (alfaFive<1) { level.imageFive.set({alfa: alfaFive + level.imageFadeSpeed }) };
    level.imageFive.draw();
  };
  if (level.drawSix) {
    var alfaSix = level.imageSix.get("alfa");
    if (alfaSix<1) { level.imageSix.set({alfa: alfaSix + level.imageFadeSpeed }) };
    level.imageSix.draw();
  };
  if (level.drawSeven) {
    var alfaSeven = level.imageSeven.get("alfa");
    if (alfaSeven<1) { level.imageSeven.set({alfa: alfaSeven + level.imageFadeSpeed }) };
    level.imageSeven.draw();
  };
  // draw images
  if (level.progress == 0) {
    if (soundOn) {
      snd.drops.play();
    } else {
      snd.drops.pause();
    }
    fade.in();
    if (fade.get("progress")==0) level.progress = 1
  } else if (level.progress==1) {
    level.drawTwo = true;
  } else if (level.progress==2) {
    snd.drops.pause();
    level.drawThree = true;
  } else if (level.progress==3) {
    level.drawFour = true;
  } else if (level.progress==4) {
    level.drawFive = true;
  } else if (level.progress==5) {
    level.drawSix = true;
  } else if (level.progress==6) {
    level.drawSeven = true;
  } else if (level.progress>=7) {
    fade.out();
    if (fade.get("progress")==100) {
      resetMutableState(current);
      current="pageThree";
    }
  }
  helpClick(450, 450);
  linker({x: 0, y: 0});
  bgMusic();
  snd.disco.pause();
  soundSwitch();
};
levelStates.pageThree = { immutable: function() {
  return({ 
    imageFadeSpeed: 0.1,
    imageOne: new Sprite({ img: img.page_three_one, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0,
    }),
    imageTwo: new Sprite({ img: img.page_three_two, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageThree: new Sprite({ img: img.page_three_three, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageFour: new Sprite({ img: img.page_three_four, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageFive: new Sprite({ img: img.page_three_five, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageSix: new Sprite({ img: img.page_three_six, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageRazor: new Sprite({ img: img.page_three_razor, 
      sw: 37, sh: 103, dw: 37, dh: 103
    }),
    imageBg: new Sprite({ img: img.page_three_bg, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648
    }),
    imageBg2: new Sprite({ img: img.page_three_bg_2, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648
    }),
    imageBg3: new Sprite({ img: img.page_three_bg_3, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648
    }),
    imageDevider: new Sprite({ img: img.page_three_devider, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648
    }),
    progress: 0,
    razorActive: false,
    scroll: 0,
    razorX: 0,
    razorY: 0,
    disableClick: false,
    drawOne: false,
    drawTwo: false,
    drawThree: false,
    drawFour: false,
    drawFive: false,
    drawSix: false,
    drawAnimation: false,
    shaveBoxes: []
  });
}
};
levelStates.pageThree.mutable = levelStates.pageThree.immutable();
function pageThree() {
  var level = levelStates.pageThree.mutable;
  // navigate through level
  if (!level.disableClick && mouseDown.length > 0 && !level.razorActive && level.progress > 2) { 
    level.progress++;
    level.disableClick=true;
    if (!level.drawFour) {
      mouseDown=[];
    }
  };
  if (level.disableClick) { 
    // small pause bf can click again
    setTimeout(function(){ level.disableClick = false }, timeBetweenClicks);
  }
  level.imageBg2.draw();
  ctx.drawImage(img.page_three_animation, 0, 0, 1152, 2592, 0, 0-level.scroll, 576, 1296);
  // shaving shaum
  ctx.fillStyle='#ffffff';
  //only first time add boxes
  if (!level.shaveBoxes.length) {
    if (soundOn) {
      snd.spray.play();
    } else {
      snd.spray.pause();
    }
    for (var x=0; x < 20; x ++) {
      for (var y=0; y < 87; y ++) {
        level.shaveBoxes.push([165+15*x, 185+5*y, 15, 5, true])
      };
    }
  }
  var activeShaveBoxCount = 0;
  for (var i=0; i<level.shaveBoxes.length; i++) {
    // shaving
    var razerCenterX = level.razorX + 10; 
    var razerCenterX2 = level.razorX + 25; 
    var razerCenterY = level.razorY + 2; 
    if ( razerCenterX >= level.shaveBoxes[i][0] && razerCenterX <= level.shaveBoxes[i][0] + level.shaveBoxes[i][2] && 
      razerCenterY >= level.shaveBoxes[i][1]  &&  razerCenterY <= level.shaveBoxes[i][1] + level.shaveBoxes[i][3] ) {

      if (level.shaveBoxes[i][4]) {

        if (soundOn) {
          snd.shave.play();
        } else {
          snd.shave.pause();
        }
      }

      level.shaveBoxes[i][4] = false

    }
    if ( razerCenterX2 >= level.shaveBoxes[i][0] && razerCenterX2 <= level.shaveBoxes[i][0] + level.shaveBoxes[i][2] && 
      razerCenterY >= level.shaveBoxes[i][1]  &&  razerCenterY <= level.shaveBoxes[i][1] + level.shaveBoxes[i][3] ) {

      if (level.shaveBoxes[i][4]) {
        if (soundOn) {
          snd.shave.play();
        } else {
          snd.shave.pause();
        }
      }
      level.shaveBoxes[i][4] = false

    }
    // shaveBoxs[i][4] is if box is present
    if (level.shaveBoxes[i][4]) {
      activeShaveBoxCount++;
      ctx.save();
      ctx.beginPath();
      // x, y, w, h
      ctx.rect(level.shaveBoxes[i][0], level.shaveBoxes[i][1], level.shaveBoxes[i][2], level.shaveBoxes[i][3]);
      ctx.fill();
      ctx.restore();
    }
  }
  if (level.progress == 0 && activeShaveBoxCount < 1218) {
    // 30% of shaved legs
    level.progress = 1; 
  } else if (level.progress == 1 && activeShaveBoxCount < 896) {
    // 60% of shaved legs
    level.progress = 2; 
  } else if (level.progress == 2 && activeShaveBoxCount < 500) {
    level.razorActive = false;
    level.progress = 3; 
  }
  ctx.drawImage(img.page_three_shave, 0, 0, 1152, 2592, 0, 0-level.scroll, 576, 1296);
  level.imageBg.draw();
  level.imageDevider.draw();
  if (level.drawOne) {
    var alfaOne = level.imageOne.get("alfa");
    if (alfaOne<1) { 
      level.imageOne.set({alfa: alfaOne + level.imageFadeSpeed }) 
    };
    level.imageOne.draw();
  };
  if (level.drawTwo) {
    var alfaTwo = level.imageTwo.get("alfa");
    if (alfaTwo<1) { level.imageTwo.set({alfa: alfaTwo + level.imageFadeSpeed }) };
    level.imageTwo.draw();
  };
  if (level.drawThree) {
    var alfaThree = level.imageThree.get("alfa");
    if (alfaThree<1) { level.imageThree.set({alfa: alfaThree + level.imageFadeSpeed }) };
    level.imageBg3.draw();
    level.imageThree.draw();
  };
  if (level.drawFour) {
    var alfaFour = level.imageFour.get("alfa");
    if (alfaFour<1) { level.imageFour.set({alfa: alfaFour + level.imageFadeSpeed }) };
    level.imageFour.draw();
  };
  if (level.drawFive) {
    var alfaFive = level.imageFive.get("alfa");
    if (alfaFive<1) { level.imageFive.set({alfa: alfaFive + level.imageFadeSpeed }) };
    level.imageFive.draw();
  };
  if (level.drawSix) {
    var alfaSix = level.imageSix.get("alfa");
    if (alfaSix<1) { level.imageSix.set({alfa: alfaSix + level.imageFadeSpeed }) };
    level.imageSix.draw();
  };
  if (level.razorActive) {
    // disable click when razor is active
    level.razorX = mouseOver[0]-24;
    level.razorY = mouseOver[1]-40;
    level.imageRazor.set({dx: level.razorX, dy: level.razorY });
    level.imageRazor.draw();
  };
  // draw images
  if (level.progress == 0) {
    fade.in();
    if (fade.get("progress")==0) {
      if (level.scroll < 550) {
        level.scroll+=15;
      } else {
        level.razorActive = true;
      }
      //  level.progress = 1
    }
  } else if (level.progress==1) {
    level.drawOne = true;
  } else if (level.progress==2) {
    level.drawTwo = true;
  } else if (level.progress==3) {
    level.drawThree = true;
  } else if (level.progress==4) {
    level.drawFour = true;
  } else if (level.progress==5) {
    level.drawFive = true;
  } else if (level.progress==6) {
    level.drawSix = true;
  } else if (level.progress>=7) {
    fade.out();
    if (fade.get("progress")==100) {
      resetMutableState(current);
      current="pageFour";
    }
  }
  if (!level.razorActive) {
    helpClick(450, 450);
  }
  linker({x: 0, y: 0});
  bgMusic();
  snd.disco.pause();
  soundSwitch();
};
levelStates.pageFour = { immutable: function() {
  return({ 
    imageFadeSpeed: 0.1,
    imageOne: new Sprite({ img: img.page_four_one, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0,
    }),
    imageTwo: new Sprite({ img: img.page_four_two, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageThree: new Sprite({ img: img.page_four_three, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageFour: new Sprite({ img: img.page_four_four, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageFive: new Sprite({ img: img.page_four_five, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageSix: new Sprite({ img: img.page_four_six, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageSeven: new Sprite({ img: img.page_four_seven, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageEight: new Sprite({ img: img.page_four_eight, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageNine: new Sprite({ img: img.page_four_nine, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageTen: new Sprite({ img: img.page_four_ten, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    progress: 0,
    disableClick: false,
    drawOne: true,
    drawTwo: false,
    drawThree: false,
    drawFour: false,
    drawFive: false,
    drawSix: false,
    drawSeven: false,
    drawEight: false,
    drawNine: false,
    drawTen: false,
    heySnd: true,
  });
}
};
levelStates.pageFour.mutable = levelStates.pageFour.immutable();
function pageFour() {
  var level = levelStates.pageFour.mutable;
  // navigate through level
  if (!level.disableClick && mouseDown.length > 0) { 
    level.progress++;
    level.disableClick=true;
    if (!level.drawFour) {
      mouseDown=[];
    }
  };
  if (level.disableClick) { 
    // small pause bf can click again
    setTimeout(function(){ level.disableClick = false }, timeBetweenClicks);
  }
  if (level.drawOne) {
    var alfaOne = level.imageOne.get("alfa");
    if (alfaOne<1) { 
      level.imageOne.set({alfa: alfaOne + level.imageFadeSpeed }) 
    };
    level.imageOne.draw();
  };
  if (level.drawTwo) {
    var alfaTwo = level.imageTwo.get("alfa");
    if (alfaTwo<1) { level.imageTwo.set({alfa: alfaTwo + level.imageFadeSpeed }) };
    level.imageTwo.draw();
  };
  if (level.drawThree) {
    var alfaThree = level.imageThree.get("alfa");
    if (alfaThree<1) { level.imageThree.set({alfa: alfaThree + level.imageFadeSpeed }) };
    level.imageThree.draw();
  };
  if (level.drawFour) {
    var alfaFour = level.imageFour.get("alfa");
    if (alfaFour<1) { level.imageFour.set({alfa: alfaFour + level.imageFadeSpeed }) };
    level.imageFour.draw();
  };
  if (level.drawFive) {
    var alfaFive = level.imageFive.get("alfa");
    if (alfaFive<1) { level.imageFive.set({alfa: alfaFive + level.imageFadeSpeed }) };
    level.heySnd = playSndOnce(snd.hey, level.heySnd)
    level.imageFive.draw();
  };
  if (level.drawSix) {
    var alfaSix = level.imageSix.get("alfa");
    if (alfaSix<1) { level.imageSix.set({alfa: alfaSix + level.imageFadeSpeed }) };
    level.imageSix.draw();
  };
  if (level.drawSeven) {
    var alfaSeven = level.imageSeven.get("alfa");
    if (alfaSeven<1) { level.imageSeven.set({alfa: alfaSeven + level.imageFadeSpeed }) };
    level.imageSeven.draw();
  };
  if (level.drawEight) {
    var alfaEight = level.imageEight.get("alfa");
    if (alfaEight<1) { level.imageEight.set({alfa: alfaEight + level.imageFadeSpeed }) };
    level.imageEight.draw();
  };
  if (level.drawNine) {
    var alfaNine = level.imageNine.get("alfa");
    if (alfaNine<1) { level.imageNine.set({alfa: alfaNine + level.imageFadeSpeed }) };
    level.imageNine.draw();
  };
  if (level.drawTen) {
    var alfaTen = level.imageTen.get("alfa");
    if (alfaTen<1) { level.imageTen.set({alfa: alfaTen + level.imageFadeSpeed }) };
    level.imageTen.draw();
  };
  // draw images
  if (level.progress == 0) {
    fade.in();
    if (fade.get("progress")==0) level.progress = 1
  } else if (level.progress==1) {
    level.drawTwo = true;
  } else if (level.progress==2) {
    level.drawThree = true;
  } else if (level.progress==3) {
    level.drawFour = true;
  } else if (level.progress==4) {
    level.drawFive = true;
  } else if (level.progress==5) {
    level.drawSix = true;
  } else if (level.progress==6) {
    level.drawSeven = true;
  } else if (level.progress==7) {
    level.drawEight = true;
  } else if (level.progress==8) {
    level.drawNine = true;
  } else if (level.progress==9) {
    level.drawTen = true;
  } else if (level.progress>=10) {
    fade.out();
    if (fade.get("progress")==100) {
      resetMutableState(current);
      current="pageFive";
    }
  }
  helpClick(450, 450);
  linker({x: 0, y: 0});
  bgMusic();
  snd.disco.pause();
  soundSwitch();
};
levelStates.pageFive = { immutable: function() {
  return({ 
    imageFadeSpeed: 0.1,
    imageOne: new Sprite({ img: img.page_five_one, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0,
    }),
    imageTwo: new Sprite({ img: img.page_five_two, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageThree: new Sprite({ img: img.page_five_three, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageFour: new Sprite({ img: img.page_five_four, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageFive: new Sprite({ img: img.page_five_five, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageSix: new Sprite({ img: img.page_five_six, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageSeven: new Sprite({ img: img.page_five_seven, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageSprite: new Sprite({ img: img.page_five_sprite, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageBg: new Sprite({ img: img.page_five_bg_one, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageBorder: new Sprite({ img: img.page_three_bg, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    progress: 0,
    disableClick: false,
    drawOne: false,
    drawTwo: false,
    drawThree: false,
    drawFour: false,
    drawFive: false,
    drawSix: false,
    drawSeven: false,
    drawSprite: false,
    drawBg: false,
    enableDressing: false,
    dressing: 0,
    pullBar: new Bar({
      x: 830, y: 530, w: 250, h: 50, text: "", 
      percent: 1, fillC: "yellow"
    }),
  });
}
};
levelStates.pageFive.mutable = levelStates.pageFive.immutable();
function pageFive() {
  var level = levelStates.pageFive.mutable;
  // navigate through level
  if (!level.disableClick && mouseDown.length > 0 && level.progress != 0) { 
    level.progress++;
    level.disableClick=true;
    if (!level.drawSeven) {
      mouseDown=[];
    }
  };
  if (level.disableClick) { 
    // small pause bf can click again
    setTimeout(function(){ level.disableClick = false }, timeBetweenClicks);
  }
  var alfaBg = level.imageBg.get("alfa");
  if (alfaBg<1) { 
    level.imageBg.set({alfa: alfaBg + level.imageFadeSpeed }) 
    level.imageSprite.set({alfa: alfaBg + level.imageFadeSpeed }) 
    level.imageBorder.set({alfa: alfaBg + level.imageFadeSpeed }) 
  };
  // navigate through level
  if ( level.enableDressing && level.progress == 0) {
    if (!level.disableClick && mouseDown.length > 0) { 
      level.pullBar.changeBy(1.5);
    } else {
      level.pullBar.changeBy(-4);
    };
  };
  // go to next level phase
  var newSx = 0;
  var pullPercent = level.pullBar.get('percent'); 
  // get numbers like 1, 2, 3, 4 ....
  newSx = (pullPercent/100).toFixed(1)*10;
  if (newSx == 10 || level.progress > 0) { newSx = 9 };
  if (pullPercent == 100) {
    level.pullBar.set({percent: 0});
    level.progress=1;
    level.disableClick = true;
  }
  level.imageBg.draw();
  ctx.drawImage(img.page_five_sprite, 0 + 2304 * newSx, 0, 2304, 1296, 0, 0, 1152, 648);

  level.imageBorder.draw();
  if (level.drawOne) {
    var alfaOne = level.imageOne.get("alfa");
    if (alfaOne<1) { 
      level.imageOne.set({alfa: alfaOne + level.imageFadeSpeed }) 
    };
    level.imageOne.draw();
  };
  if (level.drawTwo) {
    var alfaTwo = level.imageTwo.get("alfa");
    if (alfaTwo<1) { level.imageTwo.set({alfa: alfaTwo + level.imageFadeSpeed }) };
    level.imageTwo.draw();
  };
  if (level.drawThree) {
    var alfaThree = level.imageThree.get("alfa");
    if (alfaThree<1) { level.imageThree.set({alfa: alfaThree + level.imageFadeSpeed }) };
    level.imageThree.draw();
  };
  if (level.drawFour) {
    var alfaFour = level.imageFour.get("alfa");
    if (alfaFour<1) { level.imageFour.set({alfa: alfaFour + level.imageFadeSpeed }) };
    level.imageFour.draw();
  };
  if (level.drawFive) {
    var alfaFive = level.imageFive.get("alfa");
    if (alfaFive<1) { level.imageFive.set({alfa: alfaFive + level.imageFadeSpeed }) };
    level.imageFive.draw();
  };
  if (level.drawSix) {
    var alfaSix = level.imageSix.get("alfa");
    if (alfaSix<1) { level.imageSix.set({alfa: alfaSix + level.imageFadeSpeed }) };
    level.imageSix.draw();
  };
  if (level.drawSeven) {
    var alfaSeven = level.imageSeven.get("alfa");
    if (alfaSeven<1) { level.imageSeven.set({alfa: alfaSeven + level.imageFadeSpeed }) };
    level.imageSeven.draw();
  };
  // draw progress bar
  if (level.progress==0) {
    level.pullBar.draw();
  };
  // draw images
  if (level.progress == 0) {
    fade.in();
    if (fade.get("progress")==0) { 
      level.enableDressing = true 
    }
  } else if (level.progress==1) {
    level.drawOne = true;
  } else if (level.progress==2) {
    level.drawTwo = true;
  } else if (level.progress==3) {
    level.drawThree = true;
  } else if (level.progress==4) {
    level.drawFour = true;
  } else if (level.progress==5) {
    level.drawFive = true;
  } else if (level.progress==6) {
    level.drawSix = true;
  } else if (level.progress==7) {
    level.drawSeven = true;
  } else if (level.progress==8) {
    level.drawEight = true;
  } else if (level.progress==9) {
    level.drawNine = true;
  } else if (level.progress==10) {
    level.drawTen = true;
  } else if (level.progress>=11) {
    fade.out();
    if (fade.get("progress")==100) {
      resetMutableState(current);
      current="pageSix";
    }
  }

  if (newSx == 10 || level.progress > 0) { 
    helpClick(450, 450);
  } else {
    helpHold(450, 450);
  }
  linker({x: 0, y: 0});
  bgMusic();
  snd.disco.pause();
  soundSwitch();
};
levelStates.pageSix = { immutable: function() {
  return({ 
    imageFadeSpeed: 0.1,
    imageOne: new Sprite({ img: img.page_six_one, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0,
    }),
    imageTwo: new Sprite({ img: img.page_six_two, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageThree: new Sprite({ img: img.page_six_three, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageFour: new Sprite({ img: img.page_six_four, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageFive: new Sprite({ img: img.page_six_five, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageSix: new Sprite({ img: img.page_six_six, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageSeven: new Sprite({ img: img.page_six_seven, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    progress: 0,
    disableClick: false,
    drawOne: true,
    drawTwo: false,
    drawThree: false,
    drawFour: false,
    drawFive: false,
    drawSix: false,
    drawSeven: false,
    ohhSound: true
  });
}
};
levelStates.pageSix.mutable = levelStates.pageSix.immutable();
function pageSix() {
  var level = levelStates.pageSix.mutable;
  // navigate through level
  if (!level.disableClick && mouseDown.length > 0) { 
    level.progress++;
    level.disableClick=true;
    if (!level.drawFour) {
      mouseDown=[];
    }
  };
  if (level.disableClick) { 
    // small pause bf can click again
    setTimeout(function(){ level.disableClick = false }, timeBetweenClicks);
  }
  if (level.drawOne) {
    var alfaOne = level.imageOne.get("alfa");
    if (alfaOne<1) { 
      level.imageOne.set({alfa: alfaOne + level.imageFadeSpeed }) 
    };
    level.imageOne.draw();
  };
  if (level.drawTwo) {
    var alfaTwo = level.imageTwo.get("alfa");
    if (alfaTwo<1) { level.imageTwo.set({alfa: alfaTwo + level.imageFadeSpeed }) };
    level.imageTwo.draw();
  };
  if (level.drawThree) {
    var alfaThree = level.imageThree.get("alfa");
    if (alfaThree<1) { level.imageThree.set({alfa: alfaThree + level.imageFadeSpeed }) };
    level.imageThree.draw();
  };
  if (level.drawFour) {
    var alfaFour = level.imageFour.get("alfa");
    if (alfaFour<1) { level.imageFour.set({alfa: alfaFour + level.imageFadeSpeed }) };
    level.imageFour.draw();
  };
  if (level.drawFive) {
    var alfaFive = level.imageFive.get("alfa");
    if (alfaFive<1) { level.imageFive.set({alfa: alfaFive + level.imageFadeSpeed }) };
    level.imageFive.draw();
  };
  if (level.drawSix) {
    var alfaSix = level.imageSix.get("alfa");
    if (alfaSix<1) { level.imageSix.set({alfa: alfaSix + level.imageFadeSpeed }) };
    level.imageSix.draw();
  };
  if (level.drawSeven) {
    var alfaSeven = level.imageSeven.get("alfa");
    if (alfaSeven<1) { level.imageSeven.set({alfa: alfaSeven + level.imageFadeSpeed }) };
    level.imageSeven.draw();
  };
  if (level.drawEight) {
    var alfaEight = level.imageEight.get("alfa");
    if (alfaEight<1) { level.imageEight.set({alfa: alfaEight + level.imageFadeSpeed }) };
    level.imageEight.draw();
  };
  if (level.drawNine) {
    var alfaNine = level.imageNine.get("alfa");
    if (alfaNine<1) { level.imageNine.set({alfa: alfaNine + level.imageFadeSpeed }) };
    level.imageNine.draw();
  };
  if (level.drawTen) {
    var alfaTen = level.imageTen.get("alfa");
    if (alfaTen<1) { level.imageTen.set({alfa: alfaTen + level.imageFadeSpeed }) };
    level.imageTen.draw();
  };
  // draw images
  if (level.progress == 0) {
    fade.in();
    if (fade.get("progress")==0) level.progress = 1
  } else if (level.progress==1) {
    level.drawTwo = true;
  } else if (level.progress==2) {
    level.drawThree = true;
  } else if (level.progress==3) {
    level.drawFour = true;
  } else if (level.progress==4) {
    level.drawFive = true;
    level.ohhSound = playSndOnce(snd.ohh, level.ohhSound);
  } else if (level.progress==5) {
    level.drawSix = true;
  } else if (level.progress==6) {
    level.drawSeven = true;
  } else if (level.progress>=7) {
    fade.out();
    if (fade.get("progress")==100) {
      resetMutableState(current);
      current="pageSeven";
    }
  }
  helpClick(450, 450);
  linker({x: 0, y: 0});
  bgMusic();
  snd.disco.pause();
  soundSwitch();
};
levelStates.pageSeven = { immutable: function() {
  return({ 
    imageFadeSpeed: 0.1,
    imageOne: new Sprite({ img: img.page_seven_one, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0,
    }),
    imageThree: new Sprite({ img: img.page_seven_three, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageTen: new Sprite({ img: img.page_seven_ten, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    progress: 0,
    disableClick: false,
    drawOne: true,
    drawThree: false,
    drawTen: false,
    newDy: 0,
    msgSndOne: true, 
    msgSndThree: true, 
    msgSndFive: true, 
    msgSndSeven: true, 
    msgSndNine: true, 
    msgSndTen: true, 
    msgSndEleven: true, 
  });
}
};
levelStates.pageSeven.mutable = levelStates.pageSeven.immutable();
function pageSeven() {
  var level = levelStates.pageSeven.mutable;
  // navigate through level
  if (!level.disableClick && mouseDown.length > 0) { 
    level.progress++;
    level.disableClick=true;
    if (!level.drawFour) {
      mouseDown=[];
    }
  };
  if (level.disableClick) { 
    // small pause bf can click again
    setTimeout(function(){ level.disableClick = false }, timeBetweenClicks);
  }
  ctx.drawImage(img.page_seven_text, 0, 0, 1026, 1610, 320, 600-level.newDy, 513, 805 );
  ctx.drawImage(img.page_seven_bg, 0, 0, 2303, 1296, 0, 0, 1152, 648 );
  if (level.drawOne) {
    var alfaOne = level.imageOne.get("alfa");
    if (alfaOne<1) { 
      level.imageOne.set({alfa: alfaOne + level.imageFadeSpeed }) 
    };
    level.imageOne.draw();
  };
  if (level.drawThree) {
    var alfaThree = level.imageThree.get("alfa");
    if (alfaThree<1) { level.imageThree.set({alfa: alfaThree + level.imageFadeSpeed }) };
    level.imageThree.draw();
  };
  if (level.drawTen) {
    var alfaTen = level.imageTen.get("alfa");
    if (alfaTen<1) { level.imageTen.set({alfa: alfaTen + level.imageFadeSpeed }) };
    level.imageTen.draw();
  };
  // draw images
  if (level.progress == 0) {
    fade.in();
    if (fade.get("progress")==0) level.progress = 1
  } else if (level.progress==1) {
    level.newDy = 65;
    level.msgSndOne = playSndOnce(snd.msg, level.msgSndOne);
  } else if (level.progress==2) {
    level.drawThree = true;
  } else if (level.progress==3) {
    level.newDy = 130
  } else if (level.progress==4) {
    level.newDy = 250
    level.msgSndThree = playSndOnce(snd.msg, level.msgSndThree);
  } else if (level.progress==5) {
    level.newDy = 310
  } else if (level.progress==6) {
    level.newDy = 368
    level.msgSndFive = playSndOnce(snd.msg, level.msgSndFive);
  } else if (level.progress==7) {
    level.newDy = 426
  } else if (level.progress==8) {
    level.newDy = 483
    level.msgSndSeven = playSndOnce(snd.msg, level.msgSndSeven);
  } else if (level.progress==9) {
    level.newDy = 645
  } else if (level.progress==10) {
    level.drawTen = true;
    level.newDy = 710
    level.msgSndNine = playSndOnce(snd.msg, level.msgSndNine);
  } else if (level.progress==11) {
    level.drawTen = true;
    level.newDy = 770
    level.msgSndTen = playSndOnce(snd.msg, level.msgSndTen);
  } else if (level.progress==12) {
    level.drawTen = true;
    level.newDy = 830
    level.msgSndEleven = playSndOnce(snd.msg, level.msgSndEleven);
  } else if (level.progress>=13) {
    fade.out();
    if (fade.get("progress")==100) {
      resetMutableState(current);
      current="pageEight";
    }
  }
  helpClick(450, 450);
  linker({x: 0, y: 0});
  bgMusic();
  snd.disco.pause();
  soundSwitch();
};
levelStates.pageEight = { immutable: function() {
  return({ 
    imageFadeSpeed: 0.1,
    imageOne: new Sprite({ img: img.page_eight_one, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0,
    }),
    imageTwo: new Sprite({ img: img.page_eight_two,
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageThree: new Sprite({ img: img.page_eight_three, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0,
    }),
    imageFive: new Sprite({ img: img.page_eight_five, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageEight: new Sprite({ img: img.page_eight_eight, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0,
    }),
    progress: 0,
    disableClick: false,
    drawOne: true,
    drawTwo: false,
    drawThree: false,
    drawFour: false,
    drawFive: false,
    drawSix: false,
    drawSeven: false,
    drawEight: false,
    msgSndTwo: true, 
    bottleSnd: true, 
  });
}
};
levelStates.pageEight.mutable = levelStates.pageEight.immutable();
function pageEight() {
  var level = levelStates.pageEight.mutable;
  // navigate through level
  if (!level.disableClick && mouseDown.length > 0) { 
    level.progress++;
    level.disableClick=true;
    mouseDown=[];
  };
  if (level.disableClick) { 
    // small pause bf can click again
    setTimeout(function(){ level.disableClick = false }, timeBetweenClicks);
  }
  if (level.drawOne) {
    var alfaOne = level.imageOne.get("alfa");
    if (alfaOne<1) { 
      level.imageOne.set({alfa: alfaOne + level.imageFadeSpeed }) 
    };
    level.imageOne.draw();
    level.bottleSnd = playSndOnce(snd.bottle, level.bottleSnd);
  };
  if (level.drawTwo) {
    var alfaTwo = level.imageTwo.get("alfa");
    if (alfaTwo<1) { 
      level.imageTwo.set({alfa: alfaTwo + level.imageFadeSpeed }) 
    };
    level.imageTwo.draw();
  };
  if (level.drawThree) {
    var alfaThree = level.imageThree.get("alfa");
    if (alfaThree<1) { level.imageThree.set({alfa: alfaThree + level.imageFadeSpeed }) };
    level.imageThree.draw();
  };
  if (level.drawFour) {
    ctx.drawImage(img.page_eight_four, 0, 0, 1026, 1610, 320, -178, 513, 805 );
    ctx.drawImage(img.page_eight_mob, 0, 0, 2303, 1296, 0, 0, 1152, 648 );
  };
  if (level.drawFive) {
    var alfaFive = level.imageFive.get("alfa");
    if (alfaFive<1) { level.imageFive.set({alfa: alfaFive + level.imageFadeSpeed }) };
    level.imageFive.draw();
  };
  if (level.drawSix) {
    ctx.drawImage(img.page_eight_six, 0, 0, 1026, 1610, 320, -178, 513, 805 );
    ctx.drawImage(img.page_eight_mob, 0, 0, 2303, 1296, 0, 0, 1152, 648 );
    level.msgSndTwo = playSndOnce(snd.msg, level.msgSndTwo);
  };
  if (level.drawSeven) {
    ctx.drawImage(img.page_eight_seven, 0, 0, 1026, 1610, 320, -178, 513, 805 );
    ctx.drawImage(img.page_eight_mob, 0, 0, 2303, 1296, 0, 0, 1152, 648 );
  };
  if (level.drawEight) {
    var alfaEight = level.imageEight.get("alfa");
    if (alfaEight<1) { level.imageEight.set({alfa: alfaEight + level.imageFadeSpeed }) };
    level.imageEight.draw();
  };
  // draw images
  if (level.progress == 0) {
    fade.in();
    if (fade.get("progress")==0) level.progress = 1
  } else if (level.progress==1) {
    level.drawTwo = true;
  } else if (level.progress==2) {
    level.drawThree = true;
  } else if (level.progress==3) {
    level.drawFour = true;
  } else if (level.progress==4) {
    level.drawFive = true;
  } else if (level.progress==5) {
    level.drawSix = true;
  } else if (level.progress==6) {
    level.drawSeven = true;
  } else if (level.progress==7) {
    level.drawEight = true;
  } else if (level.progress>=8) {
    fade.out();
    if (fade.get("progress")==100) {
      resetMutableState(current);
      current="pageNine";
    }
  }
  helpClick(450, 450);
  linker({x: 0, y: 0});
  bgMusic();
  snd.disco.pause();
  soundSwitch();
};
levelStates.pageNine = { immutable: function() {
  return({ 
    imageFadeSpeed: 0.1,
    imageOne: new Sprite({ img: img.page_nine_one, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0,
    }),
    imageTwo: new Sprite({ img: img.page_nine_two,
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageThree: new Sprite({ img: img.page_nine_three, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0,
    }),
    imageFour: new Sprite({ img: img.page_nine_four, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0,
    }),
    imageFive: new Sprite({ img: img.page_nine_five, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageSix: new Sprite({ img: img.page_nine_six, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0,
    }),
    imageSeven: new Sprite({ img: img.page_nine_seven, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0,
    }),
    imageEight: new Sprite({ img: img.page_nine_eight, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0,
    }),
    imageNine: new Sprite({ img: img.page_nine_nine, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0,
    }),
    progress: 0,
    disableClick: false,
    drawOne: false,
    drawTwo: false,
    drawThree: false,
    drawFour: false,
    drawFive: false,
    drawSix: false,
    drawSeven: false,
    drawEight: false,
    drawNine: false,
    eyeDy: 0,
    eyeSpeed: 20
  });
}
};
levelStates.pageNine.mutable = levelStates.pageNine.immutable();
function pageNine() {
  var level = levelStates.pageNine.mutable;
  // navigate through level
  if (!level.disableClick && mouseDown.length > 0 && level.progress >= 5 ) { 
    level.progress++;
    level.disableClick=true;
    mouseDown=[];
  };
  if (level.disableClick) { 
    // small pause bf can click again
    setTimeout(function(){ level.disableClick = false }, timeBetweenClicks);
  }
  if (level.drawOne) {
    var alfaOne = level.imageOne.get("alfa");
    if (alfaOne<1) { 
      level.imageOne.set({alfa: alfaOne + level.imageFadeSpeed }) 
    };
    level.imageOne.draw();
  };
  if (level.drawTwo) {
    var alfaTwo = level.imageTwo.get("alfa");
    if (alfaTwo<1) { 
      level.imageTwo.set({alfa: alfaTwo + level.imageFadeSpeed }) 
    };
    level.imageTwo.draw();
  };
  if (level.drawThree) {
    var alfaThree = level.imageThree.get("alfa");
    if (alfaThree<1) { level.imageThree.set({alfa: alfaThree + level.imageFadeSpeed }) };
    level.imageThree.draw();
  };
  if (level.drawFour) {
    var alfaFour = level.imageFour.get("alfa");
    if (alfaFour<1) { level.imageFour.set({alfa: alfaFour + level.imageFadeSpeed }) };
    level.imageFour.draw();
  };
  if (level.drawFive) {
    var alfaFive = level.imageFive.get("alfa");
    if (alfaFive<1) { level.imageFive.set({alfa: alfaFive + level.imageFadeSpeed }) };
    level.imageFive.draw();
  };
  if (level.drawSix) {
    var alfaSix = level.imageSix.get("alfa");
    if (alfaSix<1) { level.imageSix.set({alfa: alfaSix + level.imageFadeSpeed }) };
    level.imageSix.draw();
  };
  if (level.drawSeven) {
    var alfaSeven = level.imageSeven.get("alfa");
    if (alfaSeven<1) { level.imageSeven.set({alfa: alfaSeven + level.imageFadeSpeed }) };
    level.imageSeven.draw();
  };
  if (level.drawEight) {
    var alfaEight = level.imageEight.get("alfa");
    if (alfaEight<1) { level.imageEight.set({alfa: alfaEight + level.imageFadeSpeed }) };
    level.imageEight.draw();
  };
  if (level.drawNine) {
    var alfaNine = level.imageNine.get("alfa");
    if (alfaNine<1) { level.imageNine.set({alfa: alfaNine + level.imageFadeSpeed }) };
    level.imageNine.draw();
  };
  ctx.drawImage(img.black, 0, 0, 782, 648, 0, 0-level.eyeDy, 391, 324 );
  ctx.drawImage(img.black, 0, 0, 782, 648, 0, 324+level.eyeDy, 391, 324 );
  // draw images
  if (level.progress == 0) {
    level.drawOne = true;
    if (level.eyeDy < 324) { 
      level.eyeDy += level.eyeSpeed
    } else {
      level.progress = 1
    };
  } else if (level.progress==1) {
    level.drawOne = true;
    if (level.eyeDy >= 0) { 
      level.eyeDy -= level.eyeSpeed 
    } else {
      level.progress = 2
    };
  } else if (level.progress==2) {
    level.drawOne = false;
    level.drawTwo = true;
    if (level.eyeDy < 324) { 
      level.eyeDy += level.eyeSpeed
    } else {
      level.progress = 3
    };
  } else if (level.progress==3) {
    level.drawOne = false;
    level.drawTwo = true;
    if (level.eyeDy > 0) { 
      level.eyeDy -= level.eyeSpeed
    } else {
      level.progress = 4
    };
  } else if (level.progress==4) {
    level.drawOne = false;
    level.drawTwo = false;
    level.drawThree = true;
    if (level.eyeDy < 324) { 
      level.eyeDy += level.eyeSpeed 
    } else {
      level.progress = 5
    };
  } else if (level.progress==5) {
    level.drawThree = true;
  } else if (level.progress==6) {
    level.drawFour = true;
  } else if (level.progress==7) {
    level.drawFive = true;
  } else if (level.progress==8) {
    level.drawSix = true;
  } else if (level.progress==9) {
    level.drawSeven = true;
  } else if (level.progress==10) {
    level.drawEight = true;
  } else if (level.progress==11) {
    level.drawNine = true;
  } else if (level.progress>=12) {
    fade.out();
    if (fade.get("progress")==100) {
      resetMutableState(current);
      current="pageTen";
    }
  }
  if (level.progress>=5) {
    helpClick(450, 450);
  }
  linker({x: 0, y: 0});
  bgMusic();
  snd.disco.pause();
  soundSwitch();
};
levelStates.pageTen = { immutable: function() {
  return({ 
    imageFadeSpeed: 0.1,
    imageOne: new Sprite({ img: img.page_ten_one, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0,
    }),
    imageTwo: new Sprite({ img: img.page_ten_two,
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageThree: new Sprite({ img: img.page_ten_three, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0,
    }),
    imageFour: new Sprite({ img: img.page_ten_four, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageFive: new Sprite({ img: img.page_ten_five, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageSix: new Sprite({ img: img.page_ten_six, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    progress: 0,
    disableClick: false,
    drawOne: true,
    drawTwo: false,
    drawThree: false,
    drawFour: false,
    drawFive: false,
    drawSix: false,
  });
}
};
levelStates.pageTen.mutable = levelStates.pageTen.immutable();
function pageTen() {
  var level = levelStates.pageTen.mutable;
  // navigate through level
  if (!level.disableClick && mouseDown.length > 0) { 
    level.progress++;
    level.disableClick=true;
    mouseDown=[];
  };
  if (level.disableClick) { 
    // small pause bf can click again
    setTimeout(function(){ level.disableClick = false }, timeBetweenClicks);
  }
  if (level.drawOne) {
    var alfaOne = level.imageOne.get("alfa");
    if (alfaOne<1) { 
      level.imageOne.set({alfa: alfaOne + level.imageFadeSpeed }) 
    };
    level.imageOne.draw();
  };
  if (level.drawTwo) {
    var alfaTwo = level.imageTwo.get("alfa");
    if (alfaTwo<1) { 
      level.imageTwo.set({alfa: alfaTwo + level.imageFadeSpeed }) 
    };
    level.imageTwo.draw();
    if (levelSec%2==0) {
      ctx.drawImage(img.page_ten_light_red, 0, 0, 2303, 1296, 0, 0, 1152, 648 );
    } else {
      ctx.drawImage(img.page_ten_light_blue, 0, 0, 2303, 1296, 0, 0, 1152, 648 );
    }
  };
  if (level.drawThree) {
    var alfaThree = level.imageThree.get("alfa");
    if (alfaThree<1) { level.imageThree.set({alfa: alfaThree + level.imageFadeSpeed }) };
    level.imageThree.draw();
  };
  if (level.drawFour) {
    var alfaFour = level.imageFour.get("alfa");
    if (alfaFour<1) { level.imageFour.set({alfa: alfaThree + level.imageFadeSpeed }) };
    level.imageFour.draw();
  };
  if (level.drawFive) {
    var alfaFive = level.imageFive.get("alfa");
    if (alfaFive<1) { level.imageFive.set({alfa: alfaFive + level.imageFadeSpeed }) };
    level.imageFive.draw();
  };
  if (level.drawSix) {
    var alfaSix = level.imageSix.get("alfa");
    if (alfaSix<1) { level.imageSix.set({alfa: alfaSix + level.imageFadeSpeed }) };
    level.imageSix.draw();
  };
  // draw images
  if (level.progress == 0) {
    fade.in();
    if (fade.get("progress")==0) level.progress = 1
  } else if (level.progress==1) {
    level.drawTwo = true;
  } else if (level.progress==2) {
    level.drawThree = true;
  } else if (level.progress==3) {
    level.drawFour = true;
  } else if (level.progress==4) {
    level.drawFive = true;
  } else if (level.progress==5) {
    level.drawSix = true;
  } else if (level.progress>=6) {
    fade.out();
    if (fade.get("progress")==100) {
      resetMutableState(current);
      current="pageEleven";
    }
  }
  helpClick(450, 450);
  linker({x: 0, y: 0});
  bgMusic(snd.disco);
  snd.bg_music.pause();
  soundSwitch();
};
levelStates.pageEleven = { immutable: function() {
  return({ 
    imageFadeSpeed: 0.1,
    imageSprite: new Sprite({ img: img.page_eleven_sprite, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0,
    }),
    imageOne: new Sprite({ img: img.page_eleven_one, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 1,
    }),
    imageTwo: new Sprite({ img: img.page_eleven_two,
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageThree: new Sprite({ img: img.page_eleven_three, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0,
    }),
    imageFour: new Sprite({ img: img.page_eleven_four, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    progress: 0,
    disableClick: false,
    drawOne: true,
    drawTwo: false,
    drawThree: false,
    drawFour: false,
    animate: false,
    kissBar: new Bar({
      x: 650, y: 570, w: 250, h: 50, text: "", 
      percent: 1, fillC: "yellow"
    }),
  });
}
};
levelStates.pageEleven.mutable = levelStates.pageEleven.immutable();
function pageEleven() {
  var level = levelStates.pageEleven.mutable;
  ctx.rect(0, 0, 1152, 648);
  ctx.fill();
  // navigate through level
  if (!level.disableClick && mouseDown.length > 0 && level.progress < 3) { 
    level.progress++;
    level.disableClick=true;
    mouseDown=[];
  };
  if (level.disableClick) { 
    // small pause bf can click again
    setTimeout(function(){ level.disableClick = false }, timeBetweenClicks);
  }
  if (level.drawOne) {
    var alfaOne = level.imageOne.get("alfa");
    if (alfaOne<1) { 
      level.imageOne.set({alfa: alfaOne + level.imageFadeSpeed }) 
    };
    level.imageOne.draw();
  };
  if (level.drawTwo) {
    var alfaTwo = level.imageTwo.get("alfa");
    if (alfaTwo<1) { 
      level.imageTwo.set({alfa: alfaTwo + level.imageFadeSpeed }) 
    };
    level.imageTwo.draw();
  };
  if (level.drawThree) {
    var alfaThree = level.imageThree.get("alfa");
    if (alfaThree<1) { level.imageThree.set({alfa: alfaThree + level.imageFadeSpeed }) };
    level.imageThree.draw();
  };
  if (level.drawFour) {
    var alfaFour = level.imageFour.get("alfa");
    if (alfaFour<1) { 
      level.imageFour.set({alfa: alfaFour + level.imageFadeSpeed });
      level.imageSprite.set({alfa: alfaFour + level.imageFadeSpeed });
    } else {
      level.animate = true
    };
    level.imageSprite.draw();
    level.imageFour.draw();
  };
  // draw images
  if (level.progress == 0) {
    fade.in();
    if (fade.get("progress")==0) level.progress = 1
  } else if (level.progress==1) {
    level.drawTwo = true;
  } else if (level.progress==2) {
    level.drawThree = true;
  } else if (level.progress==3) {
    level.drawFour = true;
    if (!level.disableClick && mouseDown.length > 0 && level.animate) { 
      level.imageSprite.animate({num: 10});
      level.kissBar.changeBy(0.5);

      if (soundOn) {
        snd.kissing.play();
      } else {
        snd.kissing.pause();
      }
    } else {
      level.kissBar.changeBy(-1);
      snd.kissing.pause();
    };
    if (level.kissBar.get('percent') == 100) {
      level.kissBar.set({percent: 0});
      level.progress++;
    }
    level.kissBar.draw();
  } else if (level.progress>=4) {
    fade.out();
    if (fade.get("progress")==100) {
      resetMutableState(current);
      snd.kissing.pause();
      current="pageTwelve";
    }
  }

  if (level.progress != 3) {
    helpClick(450, 450);
  } else {
    helpHold(950, 450);
  }

  linker({x: 0, y: 0});
  bgMusic(snd.disco);
  snd.bg_music.pause();
  soundSwitch();
};
levelStates.pageTwelve = { immutable: function() {
  return({ 
    imageFadeSpeed: 0.1,
    imageOne: new Sprite({ img: img.page_twelve_one, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 1,
    }),
    imageTwo: new Sprite({ img: img.page_twelve_two,
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageThree: new Sprite({ img: img.page_twelve_three, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0,
    }),
    imageFour: new Sprite({ img: img.page_twelve_four, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageFive: new Sprite({ img: img.page_twelve_five, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageSix: new Sprite({ img: img.page_twelve_six, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageSeven: new Sprite({ img: img.page_twelve_seven, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageEight: new Sprite({ img: img.page_twelve_eight, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageNine: new Sprite({ img: img.page_twelve_nine, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageTen: new Sprite({ img: img.page_twelve_ten, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageEleven: new Sprite({ img: img.page_twelve_eleven, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    progress: 0,
    disableClick: false,
    drawOne: true,
    drawTwo: false,
    drawThree: false,
    drawFour: false,
    drawFive: false,
    drawSix: false,
    drawSeven: false,
    drawEight: false,
    drawNine: false,
    drawTen: false,
    drawEleven: false,
  });
}
};
levelStates.pageTwelve.mutable = levelStates.pageTwelve.immutable();
function pageTwelve() {
  var level = levelStates.pageTwelve.mutable;
  // navigate through level
  if (!level.disableClick && mouseDown.length > 0) { 
    level.progress++;
    level.disableClick=true;
    mouseDown=[];
  };
  if (level.disableClick) { 
    // small pause bf can click again
    setTimeout(function(){ level.disableClick = false }, timeBetweenClicks);
  }
  if (level.drawOne) {
    var alfaOne = level.imageOne.get("alfa");
    if (alfaOne<1) { level.imageOne.set({alfa: alfaOne + level.imageFadeSpeed }) };
    level.imageOne.draw();
  };
  if (level.drawTwo) {
    var alfaTwo = level.imageTwo.get("alfa");
    if (alfaTwo<1) { level.imageTwo.set({alfa: alfaTwo + level.imageFadeSpeed }) };
    level.imageTwo.draw();
  };
  if (level.drawThree) {
    var alfaThree = level.imageThree.get("alfa");
    if (alfaThree<1) { level.imageThree.set({alfa: alfaThree + level.imageFadeSpeed }) };
    level.imageThree.draw();
  };
  if (level.drawFour) {
    var alfaFour = level.imageFour.get("alfa");
    if (alfaFour<1) { level.imageFour.set({alfa: alfaFour + level.imageFadeSpeed }) };
    level.imageFour.draw();
  };
  if (level.drawFive) {
    var alfaFive = level.imageFive.get("alfa");
    if (alfaFive<1) { level.imageFive.set({alfa: alfaFive + level.imageFadeSpeed }) };
    level.imageFive.draw();
  };
  if (level.drawSix) {
    var alfaSix = level.imageSix.get("alfa");
    if (alfaSix<1) { level.imageSix.set({alfa: alfaSix + level.imageFadeSpeed }) };
    level.imageSix.draw();
  };
  if (level.drawSeven) {
    var alfaSeven = level.imageSeven.get("alfa");
    if (alfaSeven<1) { level.imageSeven.set({alfa: alfaSeven + level.imageFadeSpeed }) };
    level.imageSeven.draw();
  };
  if (level.drawEight) {
    var alfaEight = level.imageEight.get("alfa");
    if (alfaEight<1) { level.imageEight.set({alfa: alfaEight + level.imageFadeSpeed }) };
    level.imageEight.draw();
  };
  if (level.drawNine) {
    var alfaNine = level.imageNine.get("alfa");
    if (alfaNine<1) { level.imageNine.set({alfa: alfaNine + level.imageFadeSpeed }) };
    level.imageNine.draw();
  };
  if (level.drawTen) {
    var alfaTen = level.imageTen.get("alfa");
    if (alfaTen<1) { level.imageTen.set({alfa: alfaTen + level.imageFadeSpeed }) };
    level.imageTen.draw();
  };
  if (level.drawEleven) {
    var alfaEleven = level.imageEleven.get("alfa");
    if (alfaEleven<1) { level.imageEleven.set({alfa: alfaEleven + level.imageFadeSpeed }) };
    level.imageEleven.draw();
  };

  if (soundOn) {
    snd.birds.play();
  } else {
    snd.birds.pause();
  }
  // draw images
  if (level.progress == 0) {
    fade.in();
    if (fade.get("progress")==0) level.progress = 1
  } else if (level.progress==1) {
    level.drawTwo = true;
  } else if (level.progress==2) {
    level.drawThree = true;
  } else if (level.progress==3) {
    level.drawFour = true;
  } else if (level.progress==4) {
    level.drawFive = true;
  } else if (level.progress==5) {
    level.drawSix = true;
  } else if (level.progress==6) {
    level.drawSeven = true;
  } else if (level.progress==7) {
    level.drawEight = true;
  } else if (level.progress==8) {
    level.drawNine = true;
  } else if (level.progress==9) {
    level.drawTen = true;
  } else if (level.progress==10) {
    level.drawEleven = true;
  } else if (level.progress>=11) {
    fade.out();
    if (fade.get("progress")==100) {
      resetMutableState(current);
      snd.birds.pause();
      current="pageThirteen";
    }
  }
  helpClick(450, 450);
  linker({x: 0, y: 0});
  snd.disco.pause();
  //bgMusic(snd.disco);
  //soundSwitch();
};
levelStates.pageThirteen = { immutable: function() {
  return({ 
    imageFadeSpeed: 0.1,
    imageSprite: new Sprite({ img: img.page_thirteen_sprite, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0,
    }),
    imageOne: new Sprite({ img: img.page_thirteen_one, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0,
    }),
    imageTwo: new Sprite({ img: img.page_thirteen_two,
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageThree: new Sprite({ img: img.page_thirteen_three, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0,
    }),
    imageFour: new Sprite({ img: img.page_thirteen_four, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageBg: new Sprite({ img: img.page_three_bg, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648
    }),
    progress: 0,
    disableClick: false,
    drawOne: true,
    drawTwo: false,
    drawThree: false,
    drawFour: false,
    animate: false,
    grabBar: new Bar({
      x: 650, y: 570, w: 250, h: 50, text: "", 
      percent: 1, fillC: "yellow"
    }),
  });
}
};
levelStates.pageThirteen.mutable = levelStates.pageThirteen.immutable();
function pageThirteen() {
  var level = levelStates.pageThirteen.mutable;
  // navigate through level
  if (!level.disableClick && mouseDown.length > 0 && level.progress >= 2) { 
    level.progress++;
    level.disableClick=true;
    mouseDown=[];
  };
  if (level.disableClick) { 
    // small pause bf can click again
    setTimeout(function(){ level.disableClick = false }, timeBetweenClicks);
  }
  if (level.drawOne) {
    var alfaOne = level.imageOne.get("alfa");
    if (alfaOne<1) { 
      level.imageOne.set({alfa: alfaOne + level.imageFadeSpeed }) 
      level.imageSprite.set({alfa: alfaOne + level.imageFadeSpeed });
    } else {
      level.animate = true
    };
    level.imageSprite.draw();
    level.imageOne.draw();
  };
  if (level.drawTwo) {
    var alfaTwo = level.imageTwo.get("alfa");
    if (alfaTwo<1) { 
      level.imageTwo.set({alfa: alfaTwo + level.imageFadeSpeed }) 
    };
    level.imageTwo.draw();
  };
  if (level.drawThree) {
    var alfaThree = level.imageThree.get("alfa");
    if (alfaThree<1) { level.imageThree.set({alfa: alfaThree + level.imageFadeSpeed }) };
    level.imageThree.draw();
  };
  if (level.drawFour) {
    var alfaFour = level.imageFour.get("alfa");
    if (alfaFour<1) { level.imageFour.set({alfa: alfaFour + level.imageFadeSpeed }) };
    level.imageFour.draw();
  };
  level.imageBg.draw();
  // draw images
  if (level.progress == 0) {
    fade.in();
    if (fade.get("progress")==0) level.progress = 1
  } else if (level.progress==1) {
    if (!level.disableClick && mouseDown.length > 0 && level.animate) { 
      level.imageSprite.animate({num: 8});
      level.grabBar.changeBy(0.5);
    } else {
      level.grabBar.changeBy(-1);
    };
    if (level.grabBar.get('percent') == 100) {
      level.grabBar.set({percent: 0});
      level.progress++;
    }
    level.grabBar.draw();
  } else if (level.progress==2) {
    level.imageSprite.animate({num: 8});
    level.drawOne = true;
  } else if (level.progress==3) {
    level.imageSprite.animate({num: 8});
    level.drawTwo = true;
  } else if (level.progress==4) {
    level.imageSprite.animate({num: 8});
    level.drawThree = true;
  } else if (level.progress==5) {
    level.imageSprite.animate({num: 8});
    level.drawFour = true;
  } else if (level.progress>=6) {
    level.imageSprite.animate({num: 8});
    fade.out();
    if (fade.get("progress")==100) {
      resetMutableState(current);
      current="pageFourteen";
    }
  }

  if (level.progress != 1) {
    helpClick(450, 450);
  } else {
    helpHold(450, 450);
  }
  linker({x: 0, y: 0});
  snd.birds.pause();
  bgMusic(snd.disco);
  snd.bg_music.pause();
  soundSwitch();
};
levelStates.pageFourteen = { immutable: function() {
  return({ 
    imageFadeSpeed: 0.1,
    imageOne: new Sprite({ img: img.page_fourteen_one, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 1,
    }),
    imageTwo: new Sprite({ img: img.page_fourteen_two,
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageThree: new Sprite({ img: img.page_fourteen_three, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0,
    }),
    imageFour: new Sprite({ img: img.page_fourteen_four, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageFive: new Sprite({ img: img.page_fourteen_five, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageSix: new Sprite({ img: img.page_fourteen_six, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageSeven: new Sprite({ img: img.page_fourteen_seven, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    progress: 0,
    disableClick: false,
    drawOne: true,
    drawTwo: false,
    drawThree: false,
    drawFour: false,
    drawFive: false,
    drawSix: false,
    drawSeven: false,
  });
}
};
levelStates.pageFourteen.mutable = levelStates.pageFourteen.immutable();
function pageFourteen() {
  var level = levelStates.pageFourteen.mutable;
  // navigate through level
  if (!level.disableClick && mouseDown.length > 0) { 
    level.progress++;
    level.disableClick=true;
    mouseDown=[];
  };
  if (level.disableClick) { 
    // small pause bf can click again
    setTimeout(function(){ level.disableClick = false }, timeBetweenClicks);
  }
  if (level.drawOne) {
    var alfaOne = level.imageOne.get("alfa");
    if (alfaOne<1) { level.imageOne.set({alfa: alfaOne + level.imageFadeSpeed }) };
    level.imageOne.draw();
  };
  if (level.drawTwo) {
    var alfaTwo = level.imageTwo.get("alfa");
    if (alfaTwo<1) { level.imageTwo.set({alfa: alfaTwo + level.imageFadeSpeed }) };
    level.imageTwo.draw();
  };
  if (level.drawThree) {
    var alfaThree = level.imageThree.get("alfa");
    if (alfaThree<1) { level.imageThree.set({alfa: alfaThree + level.imageFadeSpeed }) };
    level.imageThree.draw();
  };
  if (level.drawFour) {
    var alfaFour = level.imageFour.get("alfa");
    if (alfaFour<1) { level.imageFour.set({alfa: alfaFour + level.imageFadeSpeed }) };
    level.imageFour.draw();
  };
  if (level.drawFive) {
    var alfaFive = level.imageFive.get("alfa");
    if (alfaFive<1) { level.imageFive.set({alfa: alfaFive + level.imageFadeSpeed }) };
    level.imageFive.draw();
  };
  if (level.drawSix) {
    var alfaSix = level.imageSix.get("alfa");
    if (alfaSix<1) { level.imageSix.set({alfa: alfaSix + level.imageFadeSpeed }) };
    level.imageSix.draw();
  };
  if (level.drawSeven) {
    var alfaSeven = level.imageSeven.get("alfa");
    if (alfaSeven<1) { level.imageSeven.set({alfa: alfaSeven + level.imageFadeSpeed }) };
    level.imageSeven.draw();
  };
  // draw images
  if (level.progress == 0) {
    fade.in();
    //    if (fade.get("progress")==0) level.progress = 1
  } else if (level.progress==1) {
    level.drawOne = true;
  } else if (level.progress==2) {
    level.drawTwo = true;
  } else if (level.progress==3) {
    level.drawThree = true;
  } else if (level.progress==4) {
    level.drawFour = true;
  } else if (level.progress==5) {
    level.drawFive = true;
  } else if (level.progress==6) {
    level.drawSix = true;
  } else if (level.progress==7) {
    level.drawSeven = true;
  } else if (level.progress>=8) {
    fade.out();
    if (fade.get("progress")==100) {
      resetMutableState(current);
      current="pageFifteen";
    }
  }

  snd.disco.pause();
  helpClick(450, 450);
  linker({x: 0, y: 0});
  bgMusic();
  snd.disco.pause();
  soundSwitch();
};
levelStates.pageFifteen = { immutable: function() {
  return({ 
    imageFadeSpeed: 0.1,
    imageOne: new Sprite({ img: img.page_fifteen_one, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 1,
    }),
    imageTwo: new Sprite({ img: img.page_fifteen_two,
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageThree: new Sprite({ img: img.page_fifteen_three, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0,
    }),
    imageFour: new Sprite({ img: img.page_fifteen_four, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    progress: 0,
    disableClick: false,
    drawOne: true,
    drawTwo: false,
    drawThree: false,
    drawFour: false,
  });
}
};
levelStates.pageFifteen.mutable = levelStates.pageFifteen.immutable();
function pageFifteen() {
  var level = levelStates.pageFifteen.mutable;
  // navigate through level
  if (!level.disableClick && mouseDown.length > 0) { 
    level.progress++;
    level.disableClick=true;
    mouseDown=[];
  };
  if (level.disableClick) { 
    // small pause bf can click again
    setTimeout(function(){ level.disableClick = false }, timeBetweenClicks);
  }
  if (level.drawOne) {
    var alfaOne = level.imageOne.get("alfa");
    if (alfaOne<1) { level.imageOne.set({alfa: alfaOne + level.imageFadeSpeed }) };
    level.imageOne.draw();
  };
  if (level.drawTwo) {
    var alfaTwo = level.imageTwo.get("alfa");
    if (alfaTwo<1) { level.imageTwo.set({alfa: alfaTwo + level.imageFadeSpeed }) };
    level.imageTwo.draw();
  };
  if (level.drawThree) {
    var alfaThree = level.imageThree.get("alfa");
    if (alfaThree<1) { level.imageThree.set({alfa: alfaThree + level.imageFadeSpeed }) };
    level.imageThree.draw();
  };
  if (level.drawFour) {
    var alfaFour = level.imageFour.get("alfa");
    if (alfaFour<1) { level.imageFour.set({alfa: alfaFour + level.imageFadeSpeed }) };
    level.imageFour.draw();
  };

  if (soundOn) {
    snd.city.play();
  } else {
    snd.city.pause();
  }
  // draw images
  if (level.progress == 0) {
    fade.in();
  } else if (level.progress==1) {
    level.drawOne = true;
  } else if (level.progress==2) {
    level.drawTwo = true;
  } else if (level.progress==3) {
    level.drawThree = true;
  } else if (level.progress==4) {
    level.drawFour = true;
  } else if (level.progress>=5) {
    fade.out();
    if (fade.get("progress")==100) {
      resetMutableState(current);
      current="pageSixteen";
      snd.city.pause();
    }
  }
  if (level.progress > 0 && level.progress < 5) {
    ctx.drawImage(img.page_fifteen_fix, 0, 0, 2304, 1296, 0, 0, 1152, 648);
  }
  helpClick(450, 450);
  linker({x: 0, y: 0});
  bgMusic();
  snd.disco.pause();
  soundSwitch();
};
levelStates.pageSixteen = { immutable: function() {
  return({ 
    imageFadeSpeed: 0.1,
    imageOne: new Sprite({ img: img.page_sixteen_one, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 1,
    }),
    imageTwo: new Sprite({ img: img.page_sixteen_two,
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageThree: new Sprite({ img: img.page_sixteen_three, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0,
    }),
    imageFour: new Sprite({ img: img.page_sixteen_four, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageFive: new Sprite({ img: img.page_sixteen_five, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageSix: new Sprite({ img: img.page_sixteen_six, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    progress: 0,
    disableClick: false,
    drawOne: true,
    drawTwo: false,
    drawThree: false,
    drawFour: false,
    drawFive: false,
    drawSix: false,
    tadaSnd: true,
  });
}
};
levelStates.pageSixteen.mutable = levelStates.pageSixteen.immutable();
function pageSixteen() {
  var level = levelStates.pageSixteen.mutable;
  // navigate through level
  if (!level.disableClick && mouseDown.length > 0) { 
    level.progress++;
    level.disableClick=true;
    mouseDown=[];
  };
  if (level.disableClick) { 
    // small pause bf can click again
    setTimeout(function(){ level.disableClick = false }, timeBetweenClicks);
  }
  if (level.drawOne) {
    var alfaOne = level.imageOne.get("alfa");
    if (alfaOne<1) { level.imageOne.set({alfa: alfaOne + level.imageFadeSpeed }) };
    level.imageOne.draw();
  };
  if (level.drawTwo) {
    var alfaTwo = level.imageTwo.get("alfa");
    if (alfaTwo<1) { level.imageTwo.set({alfa: alfaTwo + level.imageFadeSpeed }) };
    level.imageTwo.draw();
  };
  if (level.drawThree) {
    var alfaThree = level.imageThree.get("alfa");
    if (alfaThree<1) { level.imageThree.set({alfa: alfaThree + level.imageFadeSpeed }) };
    level.imageThree.draw();
  };
  if (level.drawFour) {
    var alfaFour = level.imageFour.get("alfa");
    if (alfaFour<1) { level.imageFour.set({alfa: alfaFour + level.imageFadeSpeed }) };
    level.imageFour.draw();
  };
  if (level.drawFive) {
    var alfaFive = level.imageFive.get("alfa");
    if (alfaFive<1) { level.imageFive.set({alfa: alfaFive + level.imageFadeSpeed }) };
    level.imageFive.draw();
  };
  if (level.drawSix) {
    var alfaSix = level.imageSix.get("alfa");
    if (alfaSix<1) { level.imageSix.set({alfa: alfaSix + level.imageFadeSpeed }) };
    level.imageSix.draw();
  };
  // draw images
  if (level.progress == 0) {
    fade.in();
    if (fade.get("progress")==0) level.progress = 1
  } else if (level.progress==1) {
    level.drawOne = true;
  } else if (level.progress==2) {
    level.drawTwo = true;
  } else if (level.progress==3) {
    level.drawThree = true;
  } else if (level.progress==4) {
    level.drawFour = true;
  } else if (level.progress==5) {
    level.drawFive = true;
  } else if (level.progress==6) {
    level.drawSix = true;
    level.tadaSnd = playSndOnce(snd.tada, level.tadaSnd);
  } else if (level.progress>=7) {
    fade.out();
    if (fade.get("progress")==100) {
      resetMutableState(current);
      current="pageSeventeen";
    }
  }
  helpClick(450, 450);
  linker({x: 0, y: 0});
  bgMusic();
  snd.disco.pause();
  soundSwitch();
};
levelStates.pageSeventeen = { immutable: function() {
  return({ 
    imageFadeSpeed: 0.1,
    imageOne: new Sprite({ img: img.page_seventeen_one, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 1,
    }),
    imageTwo: new Sprite({ img: img.page_seventeen_two,
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageThree: new Sprite({ img: img.page_seventeen_three, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0,
    }),
    imageFour: new Sprite({ img: img.page_seventeen_four, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageFive: new Sprite({ img: img.page_seventeen_five, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageSix: new Sprite({ img: img.page_seventeen_six, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageSeven: new Sprite({ img: img.page_seventeen_seven, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageEight: new Sprite({ img: img.page_seventeen_eight, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageNine: new Sprite({ img: img.page_seventeen_nine, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageNine2: new Sprite({ img: img.page_seventeen_nine_2, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageTen: new Sprite({ img: img.page_seventeen_ten, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageTen2: new Sprite({ img: img.page_seventeen_ten_2, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageEleven: new Sprite({ img: img.page_seventeen_eleven, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageEleven2: new Sprite({ img: img.page_seventeen_eleven_2, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageTwelve: new Sprite({ img: img.page_seventeen_twelve, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageTwelve2: new Sprite({ img: img.page_seventeen_twelve_2, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageThirteen: new Sprite({ img: img.page_seventeen_thirteen, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageThirteen2: new Sprite({ img: img.page_seventeen_thirteen_2, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    progress: 0,
    disableClick: false,
    drawOne: true,
    drawTwo: false,
    drawThree: false,
    drawFour: false,
    drawFive: false,
    drawSix: false,
    drawSeven: false,
    drawEight: false,
    drawNine: false,
    drawTen: false,
    drawEleven: false,
    drawTwelve: false,
    drawThirteen: false,
    blendDy: 0,
    blendGoUp: true
  });
}
};
levelStates.pageSeventeen.mutable = levelStates.pageSeventeen.immutable();
function pageSeventeen() {
  var level = levelStates.pageSeventeen.mutable;
  if (level.blendGoUp) {
    level.blendDy -= underSec + 0.2
    if (level.blendDy <= -15 ) { level.blendGoUp = false }
  } else {
    level.blendDy += (underSec - 0.2) 
    if (level.blendDy >= 15 ) { level.blendGoUp = true }
  }
  var blendDy = level.blendDy / 4
  var blendDx = level.blendDy / 8
  // navigate through level
  if (!level.disableClick && mouseDown.length > 0) { 
    level.progress++;
    level.disableClick=true;
    mouseDown=[];
  };
  if (level.disableClick) { 
    // small pause bf can click again
    setTimeout(function(){ level.disableClick = false }, timeBetweenClicks);
  }
  if (level.drawOne) {
    var alfaOne = level.imageOne.get("alfa");
    if (alfaOne<1) { level.imageOne.set({alfa: alfaOne + level.imageFadeSpeed }) };
    level.imageOne.draw();
  };
  if (level.drawTwo) {
    var alfaTwo = level.imageTwo.get("alfa");
    if (alfaTwo<1) { level.imageTwo.set({alfa: alfaTwo + level.imageFadeSpeed }) };
    level.imageTwo.draw();
  };
  if (level.drawThree) {
    var alfaThree = level.imageThree.get("alfa");
    if (alfaThree<1) { level.imageThree.set({alfa: alfaThree + level.imageFadeSpeed }) };
    level.imageThree.draw();
  };
  if (level.drawFour) {
    var alfaFour = level.imageFour.get("alfa");
    if (alfaFour<1) { level.imageFour.set({alfa: alfaFour + level.imageFadeSpeed }) };
    level.imageFour.draw();
  };
  if (level.drawFive) {
    var alfaFive = level.imageFive.get("alfa");
    if (alfaFive<1) { level.imageFive.set({alfa: alfaFive + level.imageFadeSpeed }) };
    level.imageFive.draw();
  };
  if (level.drawSix) {
    var alfaSix = level.imageSix.get("alfa");
    if (alfaSix<1) { level.imageSix.set({alfa: alfaSix + level.imageFadeSpeed }) };
    level.imageSix.draw();
  };
  if (level.drawSeven) {
    var alfaSeven = level.imageSeven.get("alfa");
    if (alfaSeven<1) { level.imageSeven.set({alfa: alfaSeven + level.imageFadeSpeed }) };
    level.imageSeven.draw();
  };
  if (level.drawEight) {
    var alfaEight = level.imageEight.get("alfa");
    if (alfaEight<1) { level.imageEight.set({alfa: alfaEight + level.imageFadeSpeed }) };
    level.imageEight.draw();
  };
  if (level.drawNine) {
    var alfaNine = level.imageNine.get("alfa");
    if (alfaNine<1) { 
      level.imageNine.set({alfa: alfaNine + level.imageFadeSpeed })
      level.imageNine2.set({alfa: alfaNine + level.imageFadeSpeed })
    };
    level.imageNine.draw();
  };
  if (level.drawTen) {
    var alfaTen = level.imageTen.get("alfa");
    if (alfaTen<1) { 
      level.imageTen.set({alfa: alfaTen + level.imageFadeSpeed }) 
      level.imageTen2.set({alfa: alfaTen + level.imageFadeSpeed }) 
    };
    level.imageTen.draw();
    if (level.drawEleven) {
      ctx.drawImage(img.page_seventeen_blend, 0, 0, 2303, 1296, blendDx, blendDy, 1152, 648);
    }
    level.imageNine2.draw();
    level.imageTen2.draw();
  };
  if (level.drawEleven) {
    var alfaEleven = level.imageEleven.get("alfa");
    if (alfaEleven<1) { 
      level.imageEleven.set({alfa: alfaEleven + level.imageFadeSpeed }) 
      level.imageEleven2.set({alfa: alfaEleven + level.imageFadeSpeed }) 
    };
    level.imageEleven.draw();
    ctx.drawImage(img.page_seventeen_blend, 0, 0, 2303, 1296, blendDx, blendDy, 1152, 648);
    level.imageNine2.draw();
    level.imageEleven2.draw();
  };
  if (level.drawTwelve) {
    var alfaTwelve = level.imageTwelve.get("alfa");
    if (alfaTwelve<1) { 
      level.imageTwelve.set({alfa: alfaTwelve + level.imageFadeSpeed }) 
      level.imageTwelve2.set({alfa: alfaTwelve + level.imageFadeSpeed }) 
    };
    level.imageTwelve.draw();
    ctx.drawImage(img.page_seventeen_blend, 0, 0, 2303, 1296, blendDx, blendDy, 1152, 648);
    level.imageNine2.draw();
    level.imageTwelve2.draw();
  };
  if (level.drawThirteen) {
    var alfaThirteen = level.imageThirteen.get("alfa");
    if (alfaThirteen<1) { 
      level.imageThirteen.set({alfa: alfaThirteen + level.imageFadeSpeed }) 
      level.imageThirteen2.set({alfa: alfaThirteen + level.imageFadeSpeed }) 
    };
    level.imageThirteen.draw();
    ctx.drawImage(img.page_seventeen_blend, 0, 0, 2303, 1296, blendDx, blendDy, 1152, 648);
    level.imageNine2.draw();
    level.imageThirteen2.draw();
  };
  // draw images
  if (level.progress == 0) {
    fade.in();
    if (fade.get("progress")==0) level.progress = 1
  } else if (level.progress==1) {
    level.drawOne = true;
  } else if (level.progress==2) {
    level.drawTwo = true;
  } else if (level.progress==3) {
    level.drawThree = true;
  } else if (level.progress==4) {
    level.drawFour = true;
  } else if (level.progress==5) {
    level.drawFive = true;
  } else if (level.progress==6) {
    level.drawSix = true;
  } else if (level.progress==7) {
    level.drawSeven = true;
  } else if (level.progress==8) {
    level.drawEight = true;
  } else if (level.progress==9) {
    level.drawNine = true;
  } else if (level.progress==10) {
    level.drawTen = true;
  } else if (level.progress==11) {
    level.drawEleven = true;
  } else if (level.progress==12) {
    level.drawTwelve = true;
  } else if (level.progress==13) {
    level.drawThirteen = true;
  } else if (level.progress>=14) {
    fade.out();
    if (fade.get("progress")==100) {
      resetMutableState(current);
      current="pageEightteen";
    }
  }
  helpClick(450, 450);
  //linker({x: 0, y: 0});
  bgMusic();
  snd.disco.pause();
  soundSwitch();
};
levelStates.pageEightteen = { immutable: function() {
  return({ 
    imageFadeSpeed: 0.1,
    imageOne: new Sprite({ img: img.page_eightteen_one, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 1,
    }),
    imageTwo: new Sprite({ img: img.page_eightteen_two,
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageThree: new Sprite({ img: img.page_eightteen_three, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0,
    }),
    imageFour: new Sprite({ img: img.page_eightteen_four, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageFive: new Sprite({ img: img.page_eightteen_five, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageSix: new Sprite({ img: img.page_eightteen_six, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    progress: 0,
    disableClick: false,
    drawOne: true,
    drawTwo: false,
    drawThree: false,
    drawFour: false,
    drawFive: false,
    drawSix: false,
    femaleLaughSnd: true
  });
}
};
levelStates.pageEightteen.mutable = levelStates.pageEightteen.immutable();
function pageEightteen() {
  var level = levelStates.pageEightteen.mutable;
  // navigate through level
  if (!level.disableClick && mouseDown.length > 0) { 
    level.progress++;
    level.disableClick=true;
    mouseDown=[];
  };
  if (level.disableClick) { 
    // small pause bf can click again
    setTimeout(function(){ level.disableClick = false }, timeBetweenClicks);
  }
  if (level.drawOne) {
    var alfaOne = level.imageOne.get("alfa");
    if (alfaOne<1) { level.imageOne.set({alfa: alfaOne + level.imageFadeSpeed }) };
    level.imageOne.draw();
  };
  if (level.drawTwo) {
    var alfaTwo = level.imageTwo.get("alfa");
    if (alfaTwo<1) { level.imageTwo.set({alfa: alfaTwo + level.imageFadeSpeed }) };
    level.imageTwo.draw();
  };
  if (level.drawThree) {
    var alfaThree = level.imageThree.get("alfa");
    if (alfaThree<1) { level.imageThree.set({alfa: alfaThree + level.imageFadeSpeed }) };
    level.imageThree.draw();
  };
  if (level.drawFour) {
    var alfaFour = level.imageFour.get("alfa");
    if (alfaFour<1) { level.imageFour.set({alfa: alfaFour + level.imageFadeSpeed }) };
    level.imageFour.draw();
  };
  if (level.drawFive) {
    var alfaFive = level.imageFive.get("alfa");
    if (alfaFive<1) { level.imageFive.set({alfa: alfaFive + level.imageFadeSpeed }) };
    level.imageFive.draw();
  };
  if (level.drawSix) {
    var alfaSix = level.imageSix.get("alfa");
    if (alfaSix<1) { level.imageSix.set({alfa: alfaSix + level.imageFadeSpeed }) };
    level.imageSix.draw();
  };
  // draw images
  if (level.progress == 0) {
    fade.in();
    if (fade.get("progress")==0) level.progress = 1
  } else if (level.progress==1) {
    level.drawOne = true;
  } else if (level.progress==2) {
    level.drawTwo = true;
  } else if (level.progress==3) {
    level.drawThree = true;
  } else if (level.progress==4) {
    level.drawFour = true;
  } else if (level.progress==5) {
    level.drawFive = true;
  } else if (level.progress==6) {
    level.drawSix = true;
    level.femaleLaughSnd = playSndOnce(snd.female_laugh, level.femaleLaughSnd);
  } else if (level.progress>=7) {
    fade.out();
    if (fade.get("progress")==100) {
      resetMutableState(current);
      current="pageNineteen";
    }
  }
  helpClick(450, 450);
  linker({x: 0, y: 0});
  bgMusic();
  snd.disco.pause();
  soundSwitch();
};
levelStates.pageNineteen = { immutable: function() {
  return({ 
    imageFadeSpeed: 0.1,
    progress: 0,
    disableClick: false,
    drawOne: true,
    dy: 0,
    progressLast: 0,
    msgSndHer: true
  });
}
};
levelStates.pageNineteen.mutable = levelStates.pageNineteen.immutable();
function pageNineteen() {
  var level = levelStates.pageNineteen.mutable;
  // navigate through level
  if (!level.disableClick && mouseDown.length > 0) { 
    level.progress++;
    level.disableClick=true;
    mouseDown=[];
  };
  if (level.disableClick) { 
    // small pause bf can click again
    setTimeout(function(){ level.disableClick = false }, timeBetweenClicks);
  }

  var herMsgs = [1, 3, 5, 7, 9, 11, 12, 14, 16, 18, 20, 22, 24] 
  if (herMsgs.includes(level.progress)) {
    level.msgSndHer = playSndOnce(snd.msg, level.msgSndHer);
  } else {
    level.msgSndHer = true;
  }

  if (level.progress != level.progressLast && level.progress<25) {
    var extraExtraExtraLongProgres = [15];
    var extraExtraLongProgres = [12];
    var extraLongProgres = [10, 14];
    var longProgress = [3, 6, 8, 9, 11, 20, 21, 22, 24];
    var midProgress2 = [7, 13, 23];
    var midProgress = [4, 16, 17, 19];
    var smallProgress = [5];
    if ( extraExtraExtraLongProgres.includes(level.progress) ) {
      level.dy += 250;
    } else if ( extraExtraLongProgres.includes(level.progress) ) {
      level.dy += 180;
    } else if ( extraLongProgres.includes(level.progress) ) {
      level.dy += 150;
    } else if ( longProgress.includes(level.progress) ) {
      level.dy += 117;
    } else if ( midProgress2.includes(level.progress) ) {
      level.dy += 100;
    } else if ( midProgress.includes(level.progress) ) {
      level.dy += 80;
    } else if ( smallProgress.includes(level.progress) ) {
      level.dy += 70;
    } else {
      level.dy += 49;
    }
    level.progressLast = level.progress
  }
  ctx.drawImage(img.page_nineteen, 0, 0, 2303, 6200, 320, 180-level.dy, 1152, 3100 );
  ctx.drawImage(img.page_eight_mob, 0, 0, 2303, 1296, 0, 0, 1152, 648 );
  // draw images
  if (level.progress == 0) {
    fade.in();
  } else if (level.progress>=25) {
    fade.out();
    if (fade.get("progress")==100) {
      resetMutableState(current);
      current="pageTwenty";
    }
  }
  helpClick(450, 450);
  linker({x: 0, y: 0});
  bgMusic();
  snd.disco.pause();
  soundSwitch();
};
levelStates.pageTwenty = { immutable: function() {
  return({ 
    imageFadeSpeed: 0.1,
    imageOne: new Sprite({ img: img.page_twenty_one, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 1,
    }),
    imageTwo: new Sprite({ img: img.page_twenty_two,
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageThree: new Sprite({ img: img.page_twenty_three, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0,
    }),
    imageFour: new Sprite({ img: img.page_twenty_four, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageFive: new Sprite({ img: img.page_twenty_five, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    progress: 0,
    disableClick: false,
    drawOne: true,
    drawTwo: false,
    drawThree: false,
    drawFour: false,
    drawFive: false,
    ohhSnd: true
  });
}
};
levelStates.pageTwenty.mutable = levelStates.pageTwenty.immutable();
function pageTwenty() {
  var level = levelStates.pageTwenty.mutable;
  // navigate through level
  if (!level.disableClick && mouseDown.length > 0) { 
    level.progress++;
    level.disableClick=true;
    mouseDown=[];
  };
  if (level.disableClick) { 
    // small pause bf can click again
    setTimeout(function(){ level.disableClick = false }, timeBetweenClicks);
  }
  if (level.drawOne) {
    var alfaOne = level.imageOne.get("alfa");
    if (alfaOne<1) { level.imageOne.set({alfa: alfaOne + level.imageFadeSpeed }) };
    level.imageOne.draw();
  };
  if (level.drawTwo) {
    var alfaTwo = level.imageTwo.get("alfa");
    if (alfaTwo<1) { level.imageTwo.set({alfa: alfaTwo + level.imageFadeSpeed }) };
    level.imageTwo.draw();
  };
  if (level.drawThree) {
    var alfaThree = level.imageThree.get("alfa");
    if (alfaThree<1) { level.imageThree.set({alfa: alfaThree + level.imageFadeSpeed }) };
    level.imageThree.draw();
  };
  if (level.drawFour) {
    var alfaFour = level.imageFour.get("alfa");
    if (alfaFour<1) { level.imageFour.set({alfa: alfaFour + level.imageFadeSpeed }) };
    level.imageFour.draw();
  };
  if (level.drawFive) {
    var alfaFive = level.imageFive.get("alfa");
    if (alfaFive<1) { level.imageFive.set({alfa: alfaFive + level.imageFadeSpeed }) };
    level.imageFive.draw();
  };
  // draw images
  if (level.progress == 0) {
    if (soundOn) {
      snd.closet.play();
    } else {
      snd.closet.pause();
    }
    fade.in();
    if (fade.get("progress")==0) level.progress = 1
  } else if (level.progress==1) {
    level.drawOne = true;
  } else if (level.progress==2) {
    level.drawTwo = true;
  } else if (level.progress==3) {
    level.drawThree = true;
  } else if (level.progress==4) {
    level.drawFour = true;
    level.ohhSnd = playSndOnce(snd.ohh, level.ohhSnd);
  } else if (level.progress==5) {
    level.drawFive = true;
  } else if (level.progress>=6) {
    fade.out();
    if (fade.get("progress")==100) {
      resetMutableState(current);
      current="pageTwentyone";
    }
  }
  helpClick(450, 450);
  linker({x: 0, y: 0});
  snd.bg_music.pause();
  snd.disco.pause();
  //bgMusic();
  soundSwitch();
};
levelStates.pageTwentyone = { immutable: function() {
  return({ 
    imageFadeSpeed: 0.1,
    imageOne: new Sprite({ img: img.page_twentyone_one, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 1,
    }),
    handAnimation: new Sprite({ img: img.page_twentyone_handsprite, 
      sw: 300, sh: 300, dw: 150, dh: 150, alfa: 1, dx: 264, dy: 388
    }),
    fingerBar: new Bar({
      x: 820, y: 90, w: 250, h: 50, text: "", 
      percent: 1, fillC: "yellow"
    }),
    bjBar: new Bar({
      x: 820, y: 160, w: 250, h: 50, text: "", 
      percent: 1, fillC: "red"
    }),
    bjAnimation: new Sprite({ img: img.page_twentyone_bj_sprite, 
      sw: 1320, sh: 793, dw: 660, dh: 396, alfa: 0, dx: 492, dy: 252
    }),
    progress: 0,
    disableClick: false,
    drawOne: true,
    drawTwo: false,
  });
}
};
levelStates.pageTwentyone.mutable = levelStates.pageTwentyone.immutable();
function pageTwentyone() {
  var level = levelStates.pageTwentyone.mutable;
  // navigate through level
  if (!level.disableClick && mouseDown.length > 0 && level.progress != 1 && level.progress != 2) { 
    level.progress++;
    level.disableClick=true;
    mouseDown=[];
  };
  if (level.disableClick ) { 
    // small pause bf can click again
    setTimeout(function(){ level.disableClick = false }, timeBetweenClicks);
  }
  if (level.drawOne) {
    var alfaOne = level.imageOne.get("alfa");
    if (alfaOne<1) { level.imageOne.set({alfa: alfaOne + level.imageFadeSpeed }) };
    level.imageOne.draw();
    level.handAnimation.draw();
  };
  if (level.drawTwo) {
    var alfaBjAnimation = level.bjAnimation.get("alfa");
    if (alfaBjAnimation<1) { level.bjAnimation.set({alfa: alfaBjAnimation + level.imageFadeSpeed }) };
    level.bjAnimation.draw();
    level.handAnimation.draw();
  };
  // draw images
  if (level.progress == 0) {
    fade.in();
    if (fade.get("progress")==0) level.progress = 1
  } else if (level.progress==1) {
    level.drawOne = true;
    if (mouseDown.length > 0) { 
      level.handAnimation.animate({num: 2})
      level.fingerBar.changeBy(0.5);

      if (soundOn) {
        snd.mmm.play();
      } else {
        snd.mmm.pause();
      }
    } else {
      level.fingerBar.changeBy(-1);
      snd.mmm.pause();
    };
    if (level.fingerBar.get('percent') == 100) {
      level.fingerBar.set({percent: 0});
      level.progress++;
    }
    level.fingerBar.draw();
  } else if (level.progress==2) {
    snd.mmm.pause();
    level.drawTwo = true;
    if (mouseDown.length > 0) { 
      level.bjAnimation.animate({num: 12})
      level.bjBar.changeBy(0.5);

      if (soundOn) {
        snd.sucking_3.play();
      } else {
        snd.sucking_3.pause();
      }
    } else {
      level.bjBar.changeBy(-1);
      snd.sucking_3.pause();
    };
    if (level.bjBar.get('percent') == 100) {
      level.bjBar.set({percent: 0});
      level.progress++;
    }
    level.bjBar.draw();
  } else if (level.progress>=4) {
    fade.out();
    if (fade.get("progress")==100) {
      resetMutableState(current);
      current="pageTwentytwo";
      snd.sucking_3.pause();
      snd.mmm.pause();
    }
  }

  if (level.progress == 2 || level.progress == 1  ) {
    helpHold(450, 450);
  } else {
    helpClick(450, 450);
  }
  linker({x: 0, y: 0});
  snd.bg_music.pause();
  snd.disco.pause();

  //  bgMusic();
  soundSwitch();
};
levelStates.pageTwentytwo = { immutable: function() {
  return({ 
    imageFadeSpeed: 0.1,
    imageOne: new Sprite({ img: img.page_twentytwo_one, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 1,
    }),
    imageTwo: new Sprite({ img: img.page_twentytwo_two,
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageThree: new Sprite({ img: img.page_twentytwo_three,
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    progress: 0,
    disableClick: false,
    drawOne: true,
    drawTwo: false,
    drawThree: false,
    maleOhhSnd: true
  });
}
};
levelStates.pageTwentytwo.mutable = levelStates.pageTwentytwo.immutable();
function pageTwentytwo() {
  var level = levelStates.pageTwentytwo.mutable;
  // navigate through level
  if (!level.disableClick && mouseDown.length > 0) { 
    level.progress++;
    level.disableClick=true;
    mouseDown=[];
  };
  if (level.disableClick) { 
    // small pause bf can click again
    setTimeout(function(){ level.disableClick = false }, timeBetweenClicks);
  }
  if (level.drawOne) {
    var alfaOne = level.imageOne.get("alfa");
    if (alfaOne<1) { level.imageOne.set({alfa: alfaOne + level.imageFadeSpeed }) };
    level.imageOne.draw();
  };
  if (level.drawTwo) {
    var alfaTwo = level.imageTwo.get("alfa");
    if (alfaTwo<1) { level.imageTwo.set({alfa: alfaTwo + level.imageFadeSpeed }) };
    level.imageTwo.draw();
  };
  if (level.drawThree) {
    var alfaThree = level.imageThree.get("alfa");
    if (alfaThree<1) { level.imageThree.set({alfa: alfaThree + level.imageFadeSpeed }) };
    level.imageThree.draw();
  };
  // draw images
  if (level.progress == 0) {
    fade.in();
    if (fade.get("progress")==0) level.progress = 1
  } else if (level.progress==1) {
    level.drawOne = true;
  } else if (level.progress==2) {
    level.drawTwo = true;
  } else if (level.progress==3) {
    level.drawThree = true;
    level.maleOhhSnd = playSndOnce(snd.ohh_male, level.maleOhhSnd);
  } else if (level.progress>=4) {
    fade.out();
    if (fade.get("progress")==100) {
      resetMutableState(current);
      current="pageTwentythree";
    }
  }
  helpClick(450, 450);
  linker({x: 0, y: 0});
  snd.bg_music.pause();
  snd.disco.pause();
  //bgMusic();
  soundSwitch();
};
levelStates.pageTwentythree = { immutable: function() {
  return({ 
    imageFadeSpeed: 0.1,
    imageSprite: new Sprite({ img: img.page_twentythree_sprite, 
      sw: 2304, sh: 1296, dw: 1152, dh: 648, alfa: 1,
    }),
    fuckBar: new Bar({
      x: 90, y: 210, w: 250, h: 50, text: "", 
      percent: 1, fillC: "yellow"
    }),
    progress: 0,
    disableClick: false,
    drawOne: true,
  });
}
};
levelStates.pageTwentythree.mutable = levelStates.pageTwentythree.immutable();
function pageTwentythree() {
  var level = levelStates.pageTwentythree.mutable;
  // navigate through level
  if (!level.disableClick && mouseDown.length > 0 && level.progress != 1 && level.progress != 2) { 
    level.progress++;
    level.disableClick=true;
    mouseDown=[];
  };
  if (level.disableClick ) { 
    // small pause bf can click again
    setTimeout(function(){ level.disableClick = false }, timeBetweenClicks);
  }
  if (level.drawOne) {
    var alfaSprite = level.imageSprite.get("alfa");
    if (alfaSprite<1) { level.imageSprite.set({alfa: alfaSprite + level.imageFadeSpeed }) };
    level.imageSprite.draw();
  };
  // draw images
  if (level.progress == 0) {
    fade.in();
    if (fade.get("progress")==0) level.progress = 1
  } else if (level.progress==1) {
    level.drawOne = true;
    if (mouseDown.length > 0) { 
      level.imageSprite.animate({num: 10})
      level.fuckBar.changeBy(0.5);

      if (soundOn) {
        snd.sex_female.play();
        snd.sex_male.play();
      } else {
        snd.sex_female.pause();
        snd.sex_male.pause();

      }
    } else {
      level.fuckBar.changeBy(-1);
      snd.sex_female.pause();
      snd.sex_male.pause();
    };
    if (level.fuckBar.get('percent') == 100) {
      level.fuckBar.set({percent: 0});
      level.progress++;
    }
    level.fuckBar.draw();
  } else if (level.progress>=2) {
    fade.out();
    if (fade.get("progress")==100) {
      resetMutableState(current);
      snd.sex_female.pause();
      snd.sex_male.pause();
      current="pageTwentyfour";
    }
  }

  if (level.progress == 1) { 
    helpHold(450, 450);
  } else {
    helpClick(450, 450);
  }
  linker({x: 0, y: 0});
  bgMusic(snd.disco);
  snd.bg_music.pause();
  soundSwitch();
};
levelStates.pageTwentyfour = { immutable: function() {
  return({ 
    imageFadeSpeed: 0.1,
    imageSprite: new Sprite({ img: img.page_twentyfour_sprite, 
      sw: 2304, sh: 1296, dw: 1152, dh: 648, alfa: 1,
    }),
    imageCum: new Sprite({ img: img.page_twentyfour_cum, 
      sw: 2304, sh: 1296, dw: 1152, dh: 648, alfa: 1,
    }),
    fuckBar: new Bar({
      x: 90, y: 510, w: 250, h: 50, text: "", 
      percent: 1, fillC: "yellow"
    }),
    progress: 0,
    disableClick: false,
    drawOne: true,
    cumSnd: true,
    orgasmSnd: true
  });
}
};
levelStates.pageTwentyfour.mutable = levelStates.pageTwentyfour.immutable();
function pageTwentyfour() {
  var level = levelStates.pageTwentyfour.mutable;
  // navigate through level
  if (!level.disableClick && mouseDown.length > 0 && level.progress != 1 && level.progress != 2) { 
    level.progress++;
    level.disableClick=true;
    mouseDown=[];
  };
  if (level.disableClick ) { 
    // small pause bf can click again
    setTimeout(function(){ level.disableClick = false }, timeBetweenClicks);
  }
  if (level.drawOne) {
    var alfaSprite = level.imageSprite.get("alfa");
    if (alfaSprite<1) { level.imageSprite.set({alfa: alfaSprite + level.imageFadeSpeed }) };
    level.imageSprite.draw();
  };
  if (level.drawCum) {
    var alfaCum = level.imageCum.get("alfa");
    if (alfaCum<1) { level.imageCum.set({alfa: alfaCum + level.imageFadeSpeed }) };
    level.imageCum.draw();
  }
  // draw images
  if (level.progress == 0) {
    fade.in();
    if (fade.get("progress")==0) level.progress = 1
  } else if (level.progress==1) {
    level.drawOne = true;
    if (mouseDown.length > 0) { 
      level.imageSprite.animate({num: 10})
      level.fuckBar.changeBy(0.5);

      if (soundOn) {
        snd.sex_female.play();
        snd.sex_male.play();
      } else {
        snd.sex_female.pause();
        snd.sex_male.pause();
      }
    } else {
      level.fuckBar.changeBy(-1);
      snd.sex_female.pause();
      snd.sex_male.pause();
    };
    if (level.fuckBar.get('percent') == 100) {
      level.fuckBar.set({percent: 0});
      level.progress++;
    }
    level.fuckBar.draw();
  } else if (level.progress==2) {
    fade.out();
    if (fade.get("progress")==100) {
      level.progress=3;
    }
  } else if (level.progress==3) {
    fade.in();
    if (fade.get("progress")==0) level.progress = 4
    level.drawCum = true;
    level.cumSnd = playSndOnce(snd.cum, level.cumSnd);
    level.orgasmSnd = playSndOnce(snd.orgasm, level.orgasmSnd);
  } else if (level.progress>=5) {
    fade.out();
    if (fade.get("progress")==100) {
      resetMutableState(current);
      current="pageTwentyfive";
      snd.sex_female.pause();
      snd.sex_male.pause();
    }
  }
  helpClick(450, 450);

  if (level.progress == 1) { 
    helpHold(450, 450);
  } else {
    helpClick(450, 450);
  }

  linker({x: 0, y: 0});
  bgMusic(snd.disco);
  snd.bg_music.pause();
  soundSwitch();
};
levelStates.pageTwentyfive = { immutable: function() {
  return({ 
    imageFadeSpeed: 0.1,
    imageOne: new Sprite({ img: img.page_twentyfive, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 1,
    }),
    progress: 0,
    disableClick: false,
    drawOne: true,
    femaleLaughSnd: true,
    chooseBttnOne: new Button({
      paddingLeft: 10,
      paddingTop: 33,
      fillC: "#ffffff",
      fillCA: "#eae600",
      font: "30px Arial",
      textC: "black",
      x: 680,
      y: 420,
      h: 50,
      w: 430,
      text: "Do you want to lick me clean?",
      newVal: 5, 
      oldVal: 1
    }),
    chooseBttnTwo: new Button({
      paddingLeft: 10,
      fillC: "#ffffff",
      fillCA: "#eae600",
      paddingTop: 33,
      font: "30px Arial",
      textC: "black",
      x: 680,
      y: 480,
      h: 50,
      w: 430,
      text: "You ready for sloppy seconds?",
      newVal: 6, 
      oldVal: 1
    }),
    chooseBttnThree: new Button({
      paddingLeft: 10,
      fillC: "#ffffff",
      fillCA: "#eae600",
      paddingTop: 33,
      font: "30px Arial",
      textC: "black",
      x: 680,
      y: 560,
      h: 50,
      w: 430,
      text: "Let's end this!",
      newVal: 7, 
      oldVal: 1
    }),
  });
}
};
levelStates.pageTwentyfive.mutable = levelStates.pageTwentyfive.immutable();
function pageTwentyfive() {
  var level = levelStates.pageTwentyfive.mutable;
  level.femaleLaughSnd = playSndOnce(snd.female_laugh, level.femaleLaughSnd);

  // navigate through level
  if (!level.disableClick && mouseDown.length > 0 && mouseDown < 1) { 
    level.progress++;
    level.disableClick=true;
    mouseDown=[];
  };
  if (level.disableClick) { 
    // small pause bf can click again
    setTimeout(function(){ level.disableClick = false }, timeBetweenClicks);
  }

  if (level.drawOne) {
    var alfaOne = level.imageOne.get("alfa");
    if (alfaOne<1) { level.imageOne.set({alfa: alfaOne + level.imageFadeSpeed }) };
    level.imageOne.draw();
  };
  // draw images
  if (level.progress == 0) {
    fade.in();
    if (fade.get("progress")==0) level.progress = 1
  } else if (level.progress==1) {
    level.drawOne = true;
  } else if (level.progress==5) {
    // if 5 go to lick 
    fade.out();
    if (fade.get("progress")==100) {
      resetMutableState(current);
      // update to right place
      current="pageTwentysix";
    }
  } else if (level.progress==6) {
    // if 6 go to sloppy 
    fade.out();
    if (fade.get("progress")==100) {
      resetMutableState(current);
      current="pageTwentyseven";
    }
  } else if (level.progress==7) {
    // if 7 go to end 
    fade.out();
    if (fade.get("progress")==100) {
      resetMutableState(current);
      current="pageTwentyeight";
    }
  }

  if (level.progress != 5 || level.progress != 6) {
    if (level.progress == 1) {
      level.progress = level.chooseBttnTwo.click(mouseDown);
      level.chooseBttnTwo.draw(mouseOver);
    }
    if (level.progress == 1) {
      level.progress = level.chooseBttnOne.click(mouseDown);
      level.chooseBttnOne.draw(mouseOver);
    }

    if (level.progress == 1 && canEndCountdown<=0) {
      level.progress = level.chooseBttnThree.click(mouseDown);
      level.chooseBttnThree.draw(mouseOver);
    }

  }
  helpClick(450, 450);
  linker({x: 0, y: 0});
  bgMusic(snd.disco);
  snd.bg_music.pause();
  soundSwitch();
};

levelStates.pageTwentysix = { immutable: function() {
  return({ 
    imageFadeSpeed: 0.1,
    imageOne: new Sprite({ img: img.page_twentysix_one, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 1,
    }),
    imageTwo: new Sprite({ img: img.page_twentysix_two, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0,
    }),
    imageAnimation: new Sprite({ img: img.page_twentysix_sprite, 
      sw: 2304, sh: 1296, dw: 1152, dh: 648, alfa: 0,
    }),
    progress: 0,
    disableClick: false,
    countdownForQueef: 15,
    drawOne: true,
    drawTwo: false,
    drawThree: false,
    animate: false,
    queefSnd: true,
    lickBar: new Bar({
      x: 50, y: 250, w: 250, h: 50, text: "", 
      percent: 1, fillC: "yellow"
    }),
  });
}
};
levelStates.pageTwentysix.mutable = levelStates.pageTwentysix.immutable();
function pageTwentysix() {
  var level = levelStates.pageTwentysix.mutable;
  // navigate through level
  if (!level.disableClick && mouseDown.length > 0 && level.progress != 2 && level.progress != 4 && level.progress != 5 && level.progress != 6) { 
    level.progress++;
    level.disableClick=true;
    mouseDown=[];
  };
  if (level.disableClick) { 
    // small pause bf can click again
    setTimeout(function(){ level.disableClick = false }, timeBetweenClicks);
  }
  if (level.drawOne) {
    var alfaOne = level.imageOne.get("alfa");
    if (alfaOne<1) { level.imageOne.set({alfa: alfaOne + level.imageFadeSpeed }) };
    level.imageOne.draw();
  };
  if (level.drawTwo) {
    var alfaTwo = level.imageTwo.get("alfa");
    if (alfaTwo<1) { level.imageTwo.set({alfa: alfaTwo + level.imageFadeSpeed }) };
    level.imageTwo.draw();
  };
  if (level.drawThree) {
    var alfaThree = level.imageAnimation.get("alfa");
    if (alfaThree<1) { level.imageAnimation.set({alfa: alfaThree + level.imageFadeSpeed }) };

    if (level.animate) {
      level.imageAnimation.animate({num: 4});
    }
    level.imageAnimation.draw();
  };

  // draw images
  if (level.progress == 0) {
    fade.in();
    if (fade.get("progress")==0) level.progress = 1
  } else if (level.progress==1) {
    level.drawOne = true;
  } else if (level.progress==2) {
    level.queefSnd = playSndOnce(snd.queef, level.queefSnd);
    level.countdownForQueef--;
    if (level.countdownForQueef == 0) {
      level.progress = 3 
    }
  } else if (level.progress==3) {
    level.drawTwo = true;
  } else if (level.progress==4) {
    fade.out();
    if (fade.get("progress")==100) {
      level.drawThree = true;
      level.progress = 5;
    }
  } else if (level.progress == 5) {
    fade.in();
    if (fade.get("progress")==0) level.progress = 6
  } else if (level.progress == 6) {
    if (!level.disableClick && mouseDown.length > 0) { 
      level.animate = true;
      level.lickBar.changeBy(0.5);

      if (soundOn) {
        snd.sex_female.play();
        snd.sucking_male_2.play();
      } else {
        snd.sex_female.pause();
        snd.sucking_male_2.pause();

      }
    } else {
      level.animate = false;
      level.lickBar.changeBy(-1);
      snd.sex_female.pause();
      snd.sucking_male_2.pause();
    };
    if (level.lickBar.get('percent') == 100) {
      level.animate = true;
      level.lickBar.set({percent: 0});
      level.progress=7;
    }
    level.lickBar.draw();
  } else if (level.progress>=7) {
    fade.out();
    if (fade.get("progress")==100) {
      snd.sex_female.pause();
      snd.sucking_male_2.pause();
      resetMutableState(current);
      current="pageTwentyfive";
      canEndCountdown--;
    }
  }

  if (level.progress == 6) { 
    helpHold(450, 450);
  } else {
    helpClick(450, 450);
  }

  linker({x: 0, y: 0});
  bgMusic(snd.disco);
  snd.bg_music.pause();
  soundSwitch();
};

levelStates.pageTwentyseven = { immutable: function() {
  return({ 
    imageFadeSpeed: 0.1,
    imageOne: new Sprite({ img: img.page_twentyseven_one, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 1,
    }),
    imageTwo: new Sprite({ img: img.page_twentyseven_two, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0,
    }),
    imageThree: new Sprite({ img: img.page_twentyseven_three, 
      sw: 2304, sh: 1296, dw: 1152, dh: 648, alfa: 0,
    }),
    imageAnimation: new Sprite({ img: img.page_twentyseven_sprite, 
      sw: 2304, sh: 1296, dw: 1152, dh: 648, alfa: 0,
    }),
    progress: 0,
    disableClick: false,
    drawOne: true,
    drawTwo: false,
    drawThree: false,
    drawFour: false,
    animate: false,
    hmmSnd: true,
    fuckBar: new Bar({
      x: 50, y: 250, w: 250, h: 50, text: "", 
      percent: 1, fillC: "yellow"
    }),
  });
}
};
levelStates.pageTwentyseven.mutable = levelStates.pageTwentyseven.immutable();
function pageTwentyseven() {
  var level = levelStates.pageTwentyseven.mutable;
  // navigate through level
  if (!level.disableClick && mouseDown.length > 0 && level.progress < 4) { 
    level.progress++;
    level.disableClick=true;
    mouseDown=[];
  };

  if (level.disableClick) { 
    // small pause bf can click again
    setTimeout(function(){ level.disableClick = false }, timeBetweenClicks);
  }

  if (level.drawOne) {
    var alfaOne = level.imageOne.get("alfa");
    if (alfaOne<1) { level.imageOne.set({alfa: alfaOne + level.imageFadeSpeed }) };
    level.imageOne.draw();
  };
  if (level.drawTwo) {
    var alfaTwo = level.imageTwo.get("alfa");
    if (alfaTwo<1) { level.imageTwo.set({alfa: alfaTwo + level.imageFadeSpeed }) };
    level.imageTwo.draw();
  };
  if (level.drawThree) {
    var alfaThree = level.imageThree.get("alfa");
    if (alfaThree<1) { level.imageThree.set({alfa: alfaThree + level.imageFadeSpeed }) };
    level.imageThree.draw();
  };

  if (level.drawFour) {
    var alfaFour = level.imageAnimation.get("alfa");
    if (alfaFour<1) { level.imageAnimation.set({alfa: alfaFour + level.imageFadeSpeed }) };

    if (level.animate) {
      level.imageAnimation.animate({num: 8});
    }
    level.imageAnimation.draw();
  };

  // draw images
  if (level.progress == 0) {
    fade.in();
    if (fade.get("progress")==0) level.progress = 1
  } else if (level.progress==1) {
    level.drawOne = true;
  } else if (level.progress==2) {
    level.drawTwo = true;
  } else if (level.progress==3) {
    level.drawThree = true;
    level.hmmSnd = playSndOnce(snd.hmm, level.hmmSnd);
  } else if (level.progress==4) {
    fade.out();
    if (fade.get("progress")==100) {
      level.drawFour = true;
      level.progress = 5;
    }
  } else if (level.progress == 5) {
    fade.in();
    if (fade.get("progress")==0) level.progress = 6
  } else if (level.progress==6) {
    if (level.fuckBar.get('percent') == 100) {
      level.animate = true;
      level.fuckBar.set({percent: 100});
      level.progress=7;
    } else {
      if (mouseDown.length > 0) { 
        level.animate = true;
        level.fuckBar.changeBy(0.5);

        if (soundOn) {
          snd.sex_female.play();
          snd.sex_male.play();
        } else {
          snd.sex_female.pause();
          snd.sex_male.pause();

        }
      } else {
        level.animate = false;
        level.fuckBar.changeBy(-1);
        snd.sex_female.pause();
        snd.sex_male.pause();
      };
    }
    level.fuckBar.draw();
  } else if (level.progress>=7) {
    fade.out();
    if (fade.get("progress")==100) {
      resetMutableState(current);
      current="pageTwentyfive";
      canEndCountdown--;
      snd.sex_female.pause();
      snd.sex_male.pause();
    }
  }

  if (level.progress == 6) { 
    helpHold(450, 450);
  } else {
    helpClick(450, 450);
  }

  linker({x: 0, y: 0});
  bgMusic(snd.disco);
  snd.bg_music.pause();
  soundSwitch();
};

levelStates.pageTwentyeight = { immutable: function() {
  return({ 
    imageFadeSpeed: 0.1,
    imageOne: new Sprite({ img: img.page_twentyeight_one, 
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 1,
    }),
    imageTwo: new Sprite({ img: img.page_twentyeight_two,
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageThree: new Sprite({ img: img.page_twentyeight_three,
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageFour: new Sprite({ img: img.page_twentyeight_four,
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageFive: new Sprite({ img: img.page_twentyeight_five,
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageSix: new Sprite({ img: img.page_twentyeight_six,
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    imageSeven: new Sprite({ img: img.page_twentyeight_seven,
      sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
    }),
    progress: 0,
    disableClick: false,
    drawOne: true,
    drawTwo: false,
    drawThree: false,
    drawFour: false,
    drawFive: false,
    drawSix: false,
    drawSeven: false,
    femaleLaughSnd: true
  });
}
};
levelStates.pageTwentyeight.mutable = levelStates.pageTwentyeight.immutable();
function pageTwentyeight() {
  var level = levelStates.pageTwentyeight.mutable;
  // navigate through level
  if (!level.disableClick && mouseDown.length > 0) { 
    level.progress++;
    level.disableClick=true;
    mouseDown=[];
  };
  if (level.disableClick) { 
    // small pause bf can click again
    setTimeout(function(){ level.disableClick = false }, timeBetweenClicks);
  }
  if (level.drawOne) {
    var alfaOne = level.imageOne.get("alfa");
    if (alfaOne<1) { level.imageOne.set({alfa: alfaOne + level.imageFadeSpeed }) };
    level.imageOne.draw();
  };
  if (level.drawTwo) {
    var alfaTwo = level.imageTwo.get("alfa");
    if (alfaTwo<1) { level.imageTwo.set({alfa: alfaTwo + level.imageFadeSpeed }) };
    level.imageTwo.draw();
  };
  if (level.drawThree) {
    var alfaThree = level.imageThree.get("alfa");
    if (alfaThree<1) { level.imageThree.set({alfa: alfaThree + level.imageFadeSpeed }) };
    level.imageThree.draw();
  };
  if (level.drawFour) {
    var alfaFour = level.imageFour.get("alfa");
    if (alfaFour<1) { level.imageFour.set({alfa: alfaFour + level.imageFadeSpeed }) };
    level.imageFour.draw();
  };
  if (level.drawFive) {
    var alfaFive = level.imageFive.get("alfa");
    if (alfaFive<1) { level.imageFive.set({alfa: alfaFive + level.imageFadeSpeed }) };
    level.imageFive.draw();
  };
  if (level.drawSix) {
    var alfaSix = level.imageSix.get("alfa");
    if (alfaSix<1) { level.imageSix.set({alfa: alfaSix + level.imageFadeSpeed }) };
    level.imageSix.draw();
  };
  if (level.drawSeven) {
    var alfaSeven = level.imageSeven.get("alfa");
    if (alfaSeven<1) { level.imageSeven.set({alfa: alfaSeven + level.imageFadeSpeed }) };
    level.imageSeven.draw();
  };

  // draw images
  if (level.progress == 0) {
    fade.in();
    if (fade.get("progress")==0) level.progress = 1
  } else if (level.progress==1) {
    level.drawTwo = true;
  } else if (level.progress==2) {
    level.drawThree = true;
  } else if (level.progress==3) {
    level.drawFour = true;
  } else if (level.progress==4) {
    level.drawFive = true;
  } else if (level.progress==5) {
    level.drawSix = true;
  } else if (level.progress==6) {
    level.drawSeven = true;
    level.femaleLaughSnd = playSndOnce(snd.female_laugh, level.femaleLaughSnd);
  } else if (level.progress>=7) {
    fade.out();
    if (fade.get("progress")==100) {
      resetMutableState(current);
      // TODO end game
      current="pageTwentynine";
    }
  }
  helpClick(450, 450);
  linker({x: 0, y: 0});
  snd.disco.pause();
  bgMusic();
  soundSwitch();
};

levelStates.pageTwentynine = { immutable: function() {
  return({ 
    imageFadeSpeed: 0.1,
    imageEnd: new Sprite({ img: img.page_twentynine, 
      sw: 2304, sh: 1296, dw: 1152, dy: 648, dh: 648, alfa: 1
    }),
    endDy: 648, 
    progress: 0,
    disableClick: false,
    goToNewGame: false,
    copyLink: false,
    resetGame: false,
    messageSent: false,
  });
}
};
levelStates.pageTwentynine.mutable = levelStates.pageTwentynine.immutable();
function pageTwentynine() {
  var level = levelStates.pageTwentynine.mutable;
  // navigate through level
  if (!level.disableClick && mouseDown.length > 0 && mouseDown.length < 1) { 
    level.progress++;
    level.disableClick=true;
    mouseDown=[];
  };
  if (level.disableClick) { 
    // small pause bf can click again
    setTimeout(function(){ level.disableClick = false }, timeBetweenClicks);
  }

  ctx.beginPath();
  ctx.rect(0, 0, 2304, 1296);
  ctx.fillStyle = "#000000";
  ctx.fill();

  // draw images
  if (level.progress == 0) {
    fade.in();
    if (fade.get("progress")==0) level.progress = 1
  } else if (level.progress==1) {
    if (level.endDy > -70) { 
      level.endDy -= 20;
      level.imageEnd.set({dy: level.endDy }) 
    };
    level.imageEnd.draw();

    level.goToNewGame = nextGameBttn.click(mouseDown);
    nextGameBttn.draw(mouseOver);
    if (level.goToNewGame) {
      window.open("https://wetpussygames.com/adult-games/kinky-two.html", '_blank');
    }

      level.copyLink = copyLinkBttn.click(mouseDown);
      copyLinkBttn.draw(mouseOver);
      if (level.copyLink) {
        copyToClipboard("https://wetpussygames.com/adult-games/kinky-two.html")
        if (!level.messageSent) {
          var r = confirm("Link has been copied!")
          if (r) {
            level.messageSent = 1;
          } else {
            level.messageSent = 2;
          }
        }
      }


    level.resetGame = resetGameBttn.click(mouseDown);
    resetGameBttn.draw(mouseOver);
    if (level.resetGame) {
      level.progress = 2
    }

  } else if (level.progress>=2) {
    fade.out();
    if (fade.get("progress")==100) {
      resetMutableState(current);
      current="intro";
    }
  }
  linker({x: 0, y: 0});
  bgMusic();
};
